package isoformtransfer.algo;

import isoformtransfer.InferredExon;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import lmu.utils.Pair;

public class Splign extends ExternalAlgo{

    
	private File splign;

	
	public Splign(File splign){
		this.splign = splign;
		super.needFastaHeader = true;
	}
	@Override
	public List<InferredExon> parseExternalProgramOutputLine(String line) {
		if (!line.startsWith("+1") ) return null;
		String[] tokens = line.split("\t");
        InferredExon rv = new InferredExon();
        rv.infoline=line;
        if ( tokens[3].trim().equals("-")){
        	return null; //gap -> no ali
        }
     
        rv.source=new Pair<Integer,Integer>( Integer.valueOf(tokens[5].trim())-1,Integer.valueOf(tokens[6].trim()));
        rv.target=new Pair<Integer,Integer>(Integer.valueOf(tokens[7].trim())-1,Integer.valueOf(tokens[8].trim()));
        rv.dna_seqid = Double.valueOf(tokens[3]);
		
		return Arrays.asList(rv);
	}

	@Override
	public List<String> getCommand(File cdna, File DNA) {
		ArrayList<String> command = new ArrayList<String>();
		command.add(splign.getAbsolutePath());
		command.add("-subj"); 
		command.add(tmp_gene_dna.getAbsolutePath());
		command.add("-query"); 
		command.add( cdna.getAbsolutePath());
        command.add("-direction");
        command.add("sense");
        command.add("-disc");
        return command;
	}

}
