package isoformtransfer.isar.oracle;

import java.util.List;

import genome.GenomicProteinAlignment;
import isoformtransfer.isar.POMAGene;
import isoformtransfer.isar.PartialOrderMultipleAlignment.UnmappedInformation;

public interface Oracle {
    enum OracleStrategy
    {
        MULTIPLE_ALIGNMENT,
        SPLICED_ALIGNMENT,
        PROTEIN_AS_ALIGNMENT,
        
        UNDEFINED;
    }
    
    
    class Suggestion
    {
        public POMAGene g1;
        public String pId1;
        
        public POMAGene g2;
        public String pId2;
        
        public GenomicProteinAlignment gpa;
        public OracleStrategy oracleStrategy;
        
        public Suggestion(POMAGene g1,String pId1, POMAGene g2, String pId2, GenomicProteinAlignment gpa, OracleStrategy oracleStrategy) {
            this.g1 = g1;
            this.g2 = g2;
            this.gpa = gpa;
            this.pId1 = pId1;
            this.pId2 = pId2;
            this.oracleStrategy = oracleStrategy;
        }
        
        @Override
        public String toString(){
            return String.format("Genes:%s :%s; Proteins:%s-%s; SeqId: %.2f ",g1.getId(),g2.getId(),pId1,pId2,gpa.pseqid);
        }
    }
//    public OracleStrategy getOracleStrategy();
    
    public List<Suggestion> generateMappings(List<POMAGene> genes,UnmappedInformation unmappedInformation);

    public String getName();

    public boolean isRecursiveOracle();
    
}
