package lmu.utils;
import java.util.*;

public class AutoResizeVector<A> extends Vector<A> 
{
    public AutoResizeVector()
    {
        super();
    }
    public AutoResizeVector(int last_elem)
    {
        this();
        set(last_elem, null);
    }
    public A set(int index, A elem)
    {
        while (size()<=index)
        {
            add(null);
        }
        return super.set(index,elem);
    }

    public interface Updater<A>
    {
        public A update(A old_object, A new_object);
    }
    
    public void update(int index, A object, Updater<A> updater)
    {
        A old = get(index);
        if (old == null)
        {
            set(index, object);
            return;
        }
        set(index, updater.update(old, object));
    }
    
    public A get(int index)
    {
        while (size()<=index)
        {
            add(null);
        }
        return super.get(index);
    }
}
