package lmu.utils;

import java.io.*;

public class BufferPrintWriter
{
    StringWriter sw = new StringWriter(); 
    PrintWriter pw = new PrintWriter(sw);

    boolean skip = false;

    public void setSkip(boolean b)
    {
        skip = b;

    }
    public void print(String fmt)
    {
        if(skip) return;
        pw.print(fmt);
    }

    public void println(String fmt)
    {
        if(skip) return;
        pw.println(fmt);
    }

    public void printf(String fmt, Object ... params)
    {
        if(skip) return;
        pw.printf(fmt, params);
    }

    public PrintWriter getWriter()
    {
        return pw;
    }
    public String getBuffer()
    {
        pw.flush();
        sw.flush();
        return sw.getBuffer().toString();
    }
    public StringBuffer getStringBuffer()
    {
        pw.flush();
        sw.flush();
        return sw.getBuffer();
    }
    public int length()
    {
        return sw.getBuffer().length();
    }
}

                
