package lmu.utils;

import java.util.zip.*;

public class CRCCalculator 
{
    static CRC32 crc32 = new CRC32();

    static boolean[] norm_char = new boolean[Character.MAX_VALUE];

    static
    {
        for (int i=0; i<norm_char.length; i++)
        {
            norm_char[i]=false;
        }
        for (int i='a'; i<='z'; i++)
        {
            norm_char[i]=true;
        }

        for (int i='0'; i<='9'; i++)
        {
            norm_char[i]=true;
        }
    }

    
    public static String normalize(String s)
    {
        StringBuffer sb = new StringBuffer();
        for (int i=0; i<s.length(); i++)
        {
            char sc = Character.toLowerCase(s.charAt(i));
            if(!norm_char[sc])
                continue;
            
            sb.append(sc);
        }
        return sb.toString();
    }


    public static long getCrc32(String s)
    {
        synchronized(crc32)
        {
            crc32.reset();
            for (int i=0; i<s.length(); i++)
            {
                crc32.update((int)s.charAt(i));
            }
            return crc32.getValue();
        }
        
    }
    public static synchronized long getNormalizedCrc32(String s)
    {                      
        synchronized(crc32)
        {
            
            crc32.reset();
            StringBuffer sb = new StringBuffer();
            for (int i=0; i<s.length(); i++)
            {
                char sc = Character.toLowerCase(s.charAt(i));
                if(!norm_char[sc])
                    continue;
                
                crc32.update((int)sc);
            }
            return crc32.getValue();
        }
    }

    
}
