
package lmu.utils;

import java.io.File;
import java.io.IOException;
import java.util.regex.Pattern;

/** gets a config file in a given fallback list
 */
final public class ConfigFileGetter
{

    
    static String [] path=null;
    static String startDir=new File(".").getAbsolutePath();

    static final String CONFIGDIRNAME = "conf";
    static final String MATRIXDIRNAME = "matrices";
    static final String SCHEMADIRNAME = "Schemas";

    static final String SERVER_WIDE_PATH="webapps";
    static final String WS_PATH="WEB-INF";
    
    static public class ConfigFileNotFound extends Exception
    {
        String msg="";
        public ConfigFileNotFound(Class invoker, String configfilename)
        {
            msg="Config file: " + configfilename+" not found! Searched by:" + invoker.getName();
        }
        public String getMessage()
        {
            return msg;
        }
    }
    
    static boolean log4jconfigured = false;

    public static org.apache.log4j.Logger getLogger(String filename, String loggername) throws ConfigFileNotFound
    {
        if (log4jconfigured)
            return org.apache.log4j.Logger.getLogger(loggername);
        
        
        File configfile = getConfigFile(ConfigFileGetter.class, filename);
        if (!configfile.exists())
        {
            return null;
        }
        org.apache.log4j.PropertyConfigurator.configure(configfile.getAbsolutePath());
        log4jconfigured=true;
        return org.apache.log4j.Logger.getLogger(loggername);
    }

    public static void loadClassFromWs()
    {
        
        //String rp = getRootPath()+"WEB-INF"+File.separator;
        String rp = getRootPath()+File.separator;
        File libpath = new File(rp+"lib"+File.separator);
        if (!libpath.exists()) return ;
        String [] libs = libpath.list();
        String classpath="";
        java.net.URL[] urls = new java.net.URL[libs.length];
        for (int i=0; i<libs.length; i++)
        {
            if (libs[i].endsWith(".jar"))
            {
                //System.out.println(libs[i]);
                try
                {
                    urls[i]=new java.net.URL("file://", "localhost", libpath.getAbsolutePath()+File.separator+libs[i]);
                }
                catch(Exception e)
                {
                    e.printStackTrace();
                }
                
                //classpath+=libpath.getAbsolutePath()+File.separator+libs[i]+":";
            }
            
        }
        //urls[urls.length-1]=new java.net.URL("file://", "localhost", classpath+rp+"classes");
        java.net.URLClassLoader ucl = new java.net.URLClassLoader(urls);
        //return ucl.findClass(classname);
        //return classpath+rp+"classes";
    }

    static File rootDir = null;

    static void initPath()
    {
        if (path==null)
        {
            Class cls = ConfigFileGetter.class;           
            /*
            System.out.println("system classloadeR: "+cls.getClassLoader().getSystemClassLoader());
            
            path = cl.getResource("/").getFile();
            cls=ConfigFileGetter.class;
            try
            {
            
                ClassLoader cl = cls.getClassLoader();
                System.out.println("cl resourcE: "+cl.getResource("/").getFile());
                while (cl!=null)
                {
                    System.out.println("cl "+cl);
                    Class cz = (cl==cls.getClassLoader())?cls:cl.loadClass(ConfigFileGetter.class.getCanonicalName());
                    System.out.println("found class: "+cz);
                    if (cz!=null)
                    {
                        java.security.ProtectionDomain pDomain = cz.getProtectionDomain();
                        java.security.CodeSource cSource = pDomain.getCodeSource();
                        System.out.println("classloader: "+cSource.getLocation());
                    }
                    cl=cl.getParent();
                    
                }
                cls=cls.getClassLoader().getSystemClassLoader().loadClass(ConfigFileGetter.class.getCanonicalName());
                cls=ConfigFileGetter.class;
            }
            catch(ClassNotFoundException cnfe)
            {
                System.err.println("cannot happen.. class not found: "+cnfe.getMessage());
            }
            
            //java.security.ProtectionDomain pDomain=cls.getClassLoader().getSystemClassLoader().getClass().getProtectionDomain();
            java.security.ProtectionDomain pDomain = cls.getProtectionDomain();
            java.security.CodeSource cSource = pDomain.getCodeSource();
            String pathname = cSource.getLocation().getPath();
            */
            java.net.URL resurl= cls.getClassLoader().getResource("/");
            String pathname=null;
            if (resurl==null)
            {
                java.security.ProtectionDomain pDomain=cls.getClassLoader().getSystemClassLoader().getClass().getProtectionDomain();
                String cfname=ConfigFileGetter.class.getCanonicalName().replaceAll("\\.", "/")+".class";
                pathname=cls.getClassLoader().getSystemClassLoader().getResource(cfname).getPath();
                //System.out.println("cfname: "+cfname);
                //System.out.println("root sys resource: "+pathname);
                //java.security.ProtectionDomain pDomain = cls.getProtectionDomain();
                
            }
            else
            {
                pathname =resurl.getFile();
            }
            
            
            

            pathname = pathname.substring(0,pathname.length()-1);
            if (pathname.startsWith(JAR_FILE_PREFIX))
            {
                pathname = pathname.substring(JAR_FILE_PREFIX.length());
                in_jar = true;
                int splitter = pathname.indexOf('!');
                if (splitter > 0)
                {
                    pathname = pathname.substring(0, splitter);
                }
                
            }
            path = pathname.split(Pattern.quote(File.separator));



            int x=pathname.lastIndexOf(File.separator);
            String rootname=pathname.substring(0,x+1);
            rootDir = new File( pathname);
        }
        
    }
    static boolean in_jar = false;
    static final String JAR_FILE_PREFIX = "file:/";
    

    static public String getRootPath()
    {
        return getRootPath(false);
    }

    static public String getWSName()
    {
        initPath();
        for (int i=0; i<path.length-1; i++)
        {
            if (path[i+1].equals(WS_PATH)) 
            {
                return path[i];
            }
        }
        return null;
    }
    static  public String getRootPath(boolean server_wide)
    {
        initPath();
        String root=path[0];
        for (int i=1; i<path.length; i++)
        {   
            //System.out.println("path "+i+":" +path[i]);
            if (path[i].equals(WS_PATH)) 
            {
                return root+File.separator;
            }
            root+=File.separator+path[i];
            if (server_wide && path[i].equals(SERVER_WIDE_PATH))
            {
                return root+File.separator;

            }
            
        }
        return root+File.separator;
    }


    public final static File getMatrixFile(Class invoker, String matrixname) throws IOException
    {
        try
        {
            return getFile(invoker, MATRIXDIRNAME, matrixname+".mat");
        }
        catch(ConfigFileNotFound e)
        {
            throw new IOException("matrix file not found for matrix: "+matrixname +" reason : "+e.getMessage());
        }
    }
    
    public final static File getConfigFile(Class invoker, String configfilename)
        throws ConfigFileNotFound
    {
        return getFile(invoker, CONFIGDIRNAME, configfilename);
    }


    public final static File getConfigFile(String configfilename) throws ConfigFileNotFound
    {
        RuntimeException ex = new RuntimeException();
        Class invoker=ex.getStackTrace()[1].getClass();

        //System.out.println("look for "+configfilename+
        //                   " inm "+CONFIGDIRNAME);

        return getFile(invoker, CONFIGDIRNAME, configfilename);
    }
    
    
    public final static File getSchemaDir(Class invoker)
        throws ConfigFileNotFound
    {
        return getFile(invoker, SCHEMADIRNAME, "");
    }

    public final static File getSchema(Class invoker, String configfilename)
        throws ConfigFileNotFound
    {
        return getFile(invoker, SCHEMADIRNAME, configfilename);
    }

    public final static File getFile(Class invoker, String dir, String configfilename)
        throws ConfigFileNotFound
    {
        
        
        initPath();
        String pathtoConfigFile="";;
        
        
        for (int i=0; i<path.length; i++)
        {
            

            pathtoConfigFile += File.separator+path[i];
            
            final int IDX = i + 1;
            String fp = StringUtils.joinObjects(File.separator, ObjectGetter.map(IteratorUtils.getIntIterator(IDX), (_i) -> path[_i]));
            
            if (path[i].equals(SERVER_WIDE_PATH) || (i<path.length-1 && path[i+1].equals(WS_PATH))) 
            {
                //check if config file is there
                File f = new File(new File(pathtoConfigFile, dir), configfilename);
                if (f.exists()) 
                    return f;
                
            }
            
        }
        //System.out.printf("startDir: %s\n", startDir);
        File f= new File(startDir+File.separator+dir+File.separator+configfilename);
        //System.out.println(f.getAbsolutePath());
        if (f.exists()) 
            return f;
        
        //check backwards from the root of the classes
        String[] classname = (in_jar) ? new String[0] : ConfigFileGetter.class.getCanonicalName().split("\\.");

        for (int i = path.length - classname.length - 1; i >= 0; i--)
        {
            final int IDX = i + 1;
            String fp = StringUtils.joinObjects(File.separator, ObjectGetter.map(IteratorUtils.getIntIterator(IDX), (_i) -> path[_i]));
            File b = new File(File.separator + fp);
            File tocheck = new File(new File(b, dir), configfilename);

            if (tocheck.exists())
                return tocheck;
            
            
        }
        java.net.URL res = invoker.getResource(configfilename);
        if (res==null) throw new ConfigFileNotFound(invoker, configfilename);
        
        return new File(res.getFile());
        
    }


    public final static File getFile(String dir, String configfilename)
        throws ConfigFileNotFound
    {
    
        
        initPath();
        RuntimeException ex = new RuntimeException();
        Class invoker=ex.getStackTrace()[1].getClass();

        String pathtoConfigFile="";;
        for (int i=0; i<path.length; i++)
        {
            

            pathtoConfigFile+=File.separator+path[i];
            
            if (path[i].equals(SERVER_WIDE_PATH) || (i<path.length-1 && path[i+1].equals(WS_PATH))) 
            {
                
                //check if config file is there
                File f = new File(pathtoConfigFile+File.separator+dir+File.separator+configfilename);
                
                if (f.exists()) return f;
                
            }
            
        }
        
        File f= new File(startDir+dir+configfilename);
        if (f.exists()) return f;
        
        java.net.URL res = invoker.getResource(configfilename);
        if (res==null) throw new ConfigFileNotFound(invoker, configfilename);
        
        return new File(res.getFile());
        
    }

    

    
    static File binDir = null;
    public static File getBinDir()
    {
        if (binDir!=null)
        {
            return binDir;
        }
        initPath();
        return binDir= new File(rootDir, "bin");
    }


}
