package lmu.utils;

import java.io.PrintWriter;
import java.util.*;
import org.jdom.*;

public class CountUpdater
{
    String name="";
    HashMap<String, Integer> label2count = new HashMap<String, Integer>();
    int total_count=0;
    int update_count=0;

    public CountUpdater(String name)
    {
        this.name=name;
    }
    public CountUpdater()
    {

    }
    public void setName(String n)
    {
        name=n;
    }
    public int getUpdateCount()
    {
        return update_count;
    }
    public int getTotalCount()
    {
        return total_count;
    }

    public void updateAbove(int value, int[] thresholds, int increase)
    {
        if (value<=thresholds[0])
        {
            update("<="+thresholds[0], increase);
            return;
        }
        for (int i=thresholds.length-1; i>=0; i--)
        {
            if (value<thresholds[i])
                continue;
            
            update(">="+thresholds[i],increase);
            return;
        
        }
    }

    public void updateAbove(double value, double[] thresholds, int increase)
    {
        if (value<=thresholds[0])
        {
            update("<="+thresholds[0], increase);
            return;
        }
        int pre_total = total_count;
        for (int i=thresholds.length-1; i>=0; i--)
        {
            if (value<thresholds[i])
                continue;
            
            update(">="+thresholds[i],increase);
            
        
        }
        total_count=pre_total+increase;
    }
    public void updateBelow(int value, int[] thresholds, int increase)
    {
        if (value>thresholds[thresholds.length-1])
        {
            update(">"+thresholds[thresholds.length-1], increase);
            return;
        }
        int pre_total = total_count;
        for (int i=0; i<thresholds.length; i++)
        {
            if (value>thresholds[i])
                continue;
            
            update("<="+thresholds[i],increase);
            
        
        }
        total_count=pre_total+increase;
    }
    
    public void updateBelow(double value, double[] thresholds, int increase)
    {
        if (value>thresholds[thresholds.length-1])
        {
            update(">"+thresholds[thresholds.length-1], increase);
            return;
        }
        for (int i=0; i<thresholds.length; i++)
        {
            if (value>thresholds[i])
                continue;
            
            update("<="+thresholds[i],increase);
            return;
        
        }
    }

    public boolean checkinfo = false;
    public void updateMulti(int increase, String ... labels)
    {
        int save_total=total_count;
        int save_update=update_count;

        for (String l : labels)
        {
            update(l, increase);
        }
        total_count = save_total + increase;
        update_count = save_update + 1;

        if(checkinfo)
        {
            System.out.printf("checking %s total count: %d update count: %d map: %s\n", name, total_count, update_count, label2count);
        }
    }

    public void updateMulti(int increase, Collection<String>  labels)
    {
        if (labels.size() == 0)
            return;
        
        int save_total = total_count;
        int save_update = update_count;

        for (String l : labels)
        {
            update(l,increase);
        }
        total_count = save_total + increase;
        update_count = save_update + 1;
    }


    public void update(String label, int increase)
    {
        total_count+=increase;
        update_count++;

        Integer c = label2count.get(label);
        if (c==null)
        {
            label2count.put(label, increase);
            return;
        }
        label2count.put(label, c + increase);
    }

    public Integer getCount(String label)
    {
        return getCount(label, null);
    }

    public Integer getCount(String label, Integer defval)
    {
        Integer rv = label2count.get(label);
        return (rv == null) ? defval : rv;
    }

    public Vector<Pair<Integer, String> > getSortedCounts()
    {
        Vector<Pair<Integer, String> > rv = Pair.convert_reverse(label2count);
        Collections.sort(rv);
        Collections.reverse(rv);
        return rv;
    }
    public HashMap<String,Integer> getCounts()
    {
        return label2count;
    }

    public void printBestN(int n)
    {
        PrintWriter pw = new PrintWriter(System.out);
        printBestN(pw,n);
        
    }
    public void printBestN(PrintWriter pw, int n)
    {
        
        Vector<Pair<Integer,String>> v = getSortedCounts();
        if (n<0)
        {      
            n=v.size();
        }
        if (total_count==0)
        {
            return;
        }
        double norm=100.0/total_count;
        pw.printf("%s total count: %d\n", name, total_count);
        for (int i=0; i<v.size() && i<n; i++)
        {
            int c = v.get(i).getFirst();
            pw.printf("\t%s: %d (%2.2f%%)\n", v.get(i).getSecond(), c, c*norm);
        }
        pw.flush();
    }


    public Element getBestN(int n)
    {
        Element e = new Element("count_infos");
        e.setAttribute("name", name);
        e.setAttribute("total", "" + total_count);

        Vector<Pair<Integer,String>> v = getSortedCounts();
        if (n<0)
        {      
            n=v.size();
        }

        double norm = 100.0 / total_count;

        for (int i=0; i<v.size() && i<n; i++)
        {
            int c = v.get(i).getFirst();

            String name = v.get(i).getSecond();
            //name = name.replaceAll(" ", "_");
            //name = name.replaceAll("=", ":");
            Element ce = new Element("category");
            ce.setAttribute("rank", ""+(i+1));
            ce.setAttribute("name", name);
            ce.setAttribute("count", ""+c);
            ce.setAttribute("percent", String.format("%2.5f", c*norm));
            e.addContent(ce);
        }

        return e;
    }
}
