package lmu.utils;



public class DataHeader 
{
    public DataHeaderInfos parent=null;
    Logger log = LogConfig.getLogger();
    public boolean visible=true;
    String name;
    public String format;
    public ReflectedObject ref_obj = null;
    
    public int col_index=-1;
    public String fmt=null;
    
    int max_length = -1;
    
    String fieldname;
    String methodname;
    Object[] getParams;
    
    public void setVisible(boolean b)
    {
        visible=b;
    }
    public String getName()
    {
        return name;
    }

    public void setMaxLength(int ml)
    {
        max_length = ml;
    }
    
    public void setName(String n)
    {
        if (parent!=null)
        {
        }
        this.name=n;
        
    }
    public void setFormat(String fmt)
    {
        this.fmt=fmt;
    }
    public Object get(Object o)
    {
        init(o);
        if (ref_obj==null)
        {
            return o;
        }
        return ref_obj.get(o);
    
    }
    public static double minNonE = 0.001;
    public static double maxNonE = 9999;
    
    public String format(Object data)
    {
        if (fmt==null)
        {
            if ((data instanceof Double || data instanceof Float) )
            {
            	if((Math.abs((double)data)<minNonE || Math.abs((double)data) >maxNonE))
            		return String.format("%.3e", data);
            	else
            		return String.format("%3.3f", data);
            }
            return ""+data;
        }
        String rv = String.format(fmt, data);
        if (max_length < 0 || max_length <= rv.length())
        {
            return rv; 
        }
        return rv.substring(Math.max(3, max_length-4))+ " ...";
    }
    public String getFormatted(Object o)
    {
        return format(get(o));
    }
    
    public boolean isInited()
    {
        return inited;
    }
    
    boolean inited=false;
    
    public void init(Object o)
    {
        if (inited) return;
    
        log.debug("will init "+name+" on "+o);
        Object fo=o;
    
        if (ref_obj==null && (methodname!=null || ref_obj!=null))
        {
                if(getParams!=null && methodname!=null)
                {
                        log.debug("initing reflected object with params");
                        ref_obj = new ReflectedObject(methodname, getParams);
                }
                else
                {
                        ref_obj = new ReflectedObject(fieldname, methodname);
                }
    
        }
    
        if (ref_obj!=null && applyOn!=null && applyMethod!=null)
        {
            ref_obj = ReflectedObject.apply(applyOn,applyMethod, ref_obj);
        }
        if (ref_obj!=null)
        {
    
            log.debug("will init  ref obj:"+ref_obj.getInfo());
            fo = ref_obj.get(o);
        }
        if (fo==null)
        {
            return;
        }
    
        log.debug("init of "+name+" fo: "+fo+" class: "+fo.getClass().getName());
        if (! (fo instanceof Comparable))
        {
            return;
        }
    
    ;
        inited=true;
    }
    
    public ReflectedObject getRefObj()
    {
        return ref_obj;
    }
    public void setRefObj(ReflectedObject ref_obj)
    {
        this.ref_obj=ref_obj;
    }
    
    public void setExpr(String expr)
    {
        this.ref_obj=new ReflectedObject(expr);
    }
    

    public void setMethod(String method)
    {
        methodname=method;
    }
    public void setField(String name)
    {
        fieldname=name;
        if (methodname==null)
        {
            methodname="get"+Character.toUpperCase(name.charAt(0))+name.substring(1);
        }
    }
    public void setGetParams(Object[] param)
    {
        this.getParams= param;
    }
    
    Object applyOn = null;
    String applyMethod = null;
    
    public void setApplyOn(Object o)
    {
        applyOn=o;
    }
    
    public void setApplyMethod(String method)
    {
        applyMethod=method;
    }

}
