package lmu.utils;

import java.util.Iterator;
import java.util.Vector;

public class IncrementableVector implements Iterator<Vector<Integer>>
{
    public Vector<Integer> v  = new Vector<Integer>();

    public Vector<Integer> startdimensions = new Vector<Integer>();
    public Vector<Integer> dimensions;

    void init(Vector<Integer> dimensions)
    {
        for (Integer i : dimensions )
        {
            v.add(0);
            startdimensions.add(0);
        }
    }
    
    public void reset()
    {
        for (int i=0; i<dimensions.size(); i++)
        {
            v.set(i, startdimensions.get(i));
        }
    }

    public void setNumDimensions(int dim)
    {
        if(dimensions==null)
        {
            dimensions= new Vector<Integer>();
        }
        dimensions.clear();
        v.clear();
        startdimensions.clear();

        for (int i=0; i<dim; i++)
        {
            dimensions.add(0);
            startdimensions.add(0);
            v.add(0);
        }
    }

    public String getSpaceInfo()
    
    {
        return String.format("%s => %s", ""+startdimensions, ""+dimensions);
    }

    public void setDimensionRange(int dimension, int start, int end)
    {
        startdimensions.set(dimension, start);
        dimensions.set(dimension,end);
        
    }

    public IncrementableVector(int ... dimensions)
    {
        this.dimensions=new Vector<Integer>();
        for (int i : dimensions)
        {
            this.dimensions.add(i);
        }
        init(this.dimensions);

    }

    public  IncrementableVector(Vector<Integer> dimensions)
    {
        this.dimensions=dimensions;
        init(this.dimensions);
    }

    
    public String toString()
    {
        StringBuffer sb = new StringBuffer();
        sb.append('[');

        for (int i=0; i<v.size(); i++)
        {
            sb.append(""+v.get(i));
            if (i<v.size()-1)
            {
                sb.append(',');
            }
        }
        sb.append(']');
        return sb.toString();
    }

    public boolean hasNext()
    {
        for (int p=dimensions.size()-1; p>=0; p--)
        {
            if (v.get(p)<dimensions.get(p)-1)
                return true;

            if (p==0)
                return false;
            
        }
        return true;

    }

    public void remove()
    {
        throw new UnsupportedOperationException();
    }
    boolean _increment_before=false;
    
    public Vector<Integer> next()
    {
        if(_increment_before)
        {
            if(!increment())
                return null;
        }
        _increment_before=true;
        return v;
    }
    public boolean increment()
    {

        for (int p=dimensions.size()-1; p>=0; p--)
        {
            if (v.get(p)<dimensions.get(p)-1)
            {
                v.set(p, v.get(p)+1);
                for (int i=p+1; i<v.size(); i++)
                {
                    v.set(i, startdimensions.get(i));
                }
                return true;
            }

            if (p==0)
                return false;

            
            
        }
        return false;
    }

    public static void main (String args[]) 
    {
        int should = 1;
        Vector<Integer> dims = new Vector<Integer>();
        for (int i=0; i<args.length; i++)
        {
            int d = Integer.parseInt(args[i]);
            dims.add(d);
            should*=d;
        }
        
        IncrementableVector iv = new IncrementableVector(0);
        iv.setNumDimensions(dims.size());
        for (int i=0; i< dims.size(); i++)
        {
            iv.setDimensionRange(i, 0, dims.get(i));
        }

//    	Vector<Integer> dim = new Vector<Integer>();
//    	for(int i=0; i<10; i++)
//    	{
//    		dim.add(2);
//    	}
//    	IncrementableVector iv = new IncrementableVector(dim);
        int ni=0;
        do
        {
            System.out.println(iv);
            ni++;
        }
        while (iv.increment());

        System.out.println("ni: "+ni+" should: " + (should));


        iv = new IncrementableVector(3, 5, 2, 4);
        ni=0;
        while (iv.hasNext())
        {
            Vector<Integer> n = iv.next();
            System.out.println(n);
            ni++;
        }
        System.out.println("ni: "+ni+" should: " + (3*5*2*4));
        
    }
} 
