package lmu.utils;

import java.util.*;

public class IteratorIterator<I> implements Iterator<I>
{
    LinkedList<Iterator<I>> itlist = new LinkedList<Iterator<I>>();

    Iterator<I> current = null;
    Iterator<Iterator<I>> itit = null;

    

    public IteratorIterator()
    {

    }

    

        
    public IteratorIterator(Collection<I> ... cs)
    {
        for(Collection<I> c : cs)
        {
            
        
            if (c == null)
                continue;
            
            itlist.add(c.iterator());
        }
        init();
    }
    public IteratorIterator(Iterator<I> ... its)
    {
        for (Iterator<I> it: its)
        {
            itlist.add(it);
        }
        init();
    }
    public IteratorIterator(Iterator<I> it)
    {
        itlist.add(it);
        init();

    }
    

    public IteratorIterator(Collection<Iterator<I>> its)
    {
        itlist.addAll(its);
        init();
    }
    

    public void add(Iterator<I> it)
    {
        itlist.add(it);
        init();
    }
    void init()
    {
        itit=itlist.iterator();
        while (itit.hasNext() && (current == null || !current.hasNext()))
        {
            current = itit.next();
        }
    }
    public boolean hasNext()
    {
        return (current!=null && current.hasNext());
    }

    public I next()
    {
        if (current == null || !current.hasNext())
            return null; 
        
        I rv = current.next();
        while(!current.hasNext() && itit.hasNext())
        {
            current = itit.next();
        }
        return rv;
    }

    public void remove()
    {
        if (current==null)
            throw new RuntimeException("invalid operation on null current...");
        
        current.remove();
    }
}

