package lmu.utils;

import java.util.*;

public class MixedDataIterator
{
    Integer data_length = null;

    protected int region_start=0;

    class RegionDataIterator implements Iterator<Pair<Integer,Double>>
    {
        int start;
        int idx;
        double[] d;
        Pair<Integer,Double> p;

        public RegionDataIterator(int start, double[] d, Pair<Integer, Double> p)
        {
            this.p=p; this.d=d; this.start=start; idx=0;
        }
        public boolean hasNext()
        {
            return idx<d.length;
        }

        public Pair<Integer,Double> next()
        {
            p.setFirst(region_start+start+idx);
            p.setSecond(d[idx]);
            idx++;
            return p;
        }
        public void remove()
        {
            throw new RuntimeException("not supported");
        }

    }

    public int getDataLength()
    {
        return data_length;
    }
    public MixedDataIterator(int length)
    {
        data_length=length;
    }
    protected Vector<Pair<Integer,Double>> data = new Vector<Pair<Integer,Double>>();
    protected Vector<Pair<Integer, double[]> > data_arrays = new Vector<Pair<Integer, double[]> >();
    protected double [] data_full;

    Pair<Integer,Double> d = new Pair<Integer,Double>(0,0.0);

    public void addDataRegion(int region_start, double[] region_data)
    {
        if (region_start+region_data.length>data_length)
        {
            throw new RuntimeException("invalid region: "+region_start+" with length "+region_data.length+" region size is : "+data_length+"\ncaller: "+ExceptionManager.logCallerStack());
        }
        data_arrays.add(new Pair<Integer,double[]>(region_start, region_data));
    }

    public void addDataRegion(int region_start, int[] region_data)
    {
        if (region_start+region_data.length>data_length)
        {
            throw new RuntimeException("invalid region: "+region_start+" with length "+region_data.length+" region size is : "+data_length+"\ncaller: "+ExceptionManager.logCallerStack());
        }
        
        data_arrays.add(new Pair<Integer,double[]>(region_start, NumUtils.toDoubleArray(region_data)));
    }

    public void addDataPoint(int x, double d)
    {
        data.add(new Pair<Integer,Double>(x,d));
    }

    public void setDenseData(int[] data)
    {
        data_full=new double[data.length];
        for (int i=0; i<data.length; i++)
        {
            data_full[i]=(double)data[i];
        }
    }
    public void setDenseData(double[] data)
    {
        data_full=data;
        
    }

    
    public Iterator<Pair<Integer,Double>> getIterator()
    {
        Pair<Integer,Double> global_p = new Pair<Integer,Double>(0, 0.00);
        IteratorIterator<Pair<Integer,Double>> rv =new IteratorIterator<Pair<Integer,Double>>();

        if (data_full!=null)
        {
            rv.add(new RegionDataIterator(0, data_full, global_p));
        }
        for (Pair<Integer, double[]> d: data_arrays)
        {
            rv.add(new RegionDataIterator(d.getFirst(), d.getSecond(), global_p));
        }

        rv.add(data.iterator());

        return rv;
    }

}
