package lmu.utils;

import java.util.*;
import java.awt.image.*;
import java.awt.*;

public class NonOverlapRegionImage
{

    int from; int to;
    int length;
    int spacer;
    Vector<int[]> rows =new Vector<int[]>();
    Vector<int[]> starts =new Vector<int[]>();

    int row_height=3;
    int row_spacer=2;

    public NonOverlapRegionImage(int from, int to, int spacer)
    {
        this.spacer=spacer;
        this.from=from;
        this.to=to;
        length=1+to-from;
    }
    public void addRegion(int ax1, int ax2)
    {
        addRegion(ax1,ax2, -1);
    }
    
    public void addRegion(int ax1, int ax2, int start)
    {
        int x1 = ax1-from;
        int x2 = ax2-from;
        int[] target = null;
        int[] start_target=null;
        for (int ri=0; ri<rows.size(); ri++)
        {
            int[] r =rows.get(ri);
            int[] sr = starts.get(ri);
            boolean valid=true;
            int tx1=Math.max(0, x1-spacer);
            int tx2=Math.min(length, x2+spacer);
            
            for (int p=tx1; valid && p<tx2; p++)
            {
                valid=(r[p]==0);
            }
            if (!valid)
                continue;
            
            target=r;
            start_target=sr;
            break;
        }
        if (target==null)
        {
            rows.add(target=new int[length]);
            starts.add(start_target=new int[length]);
        }
        for (int p=x1; p<x2; p++)
        {
            target[p]=1;
        }
        if (start>=0)
        {
            start_target[start-from]=1;
        }
    }

    void setRGB(BufferedImage bim, int[] r, int x, int RGB)
    {
        for (int j=x,k=0; k<row_height; j++, k++)
        {
            for (int p=0; p<r.length; p++)
            {
                if (r[p]==0)
                    continue;


                bim.setRGB(p, j, RGB);
            }
        }

    }
    public BufferedImage getImage()
    {
        int RW=row_height+row_spacer;
        int h = (rows.size()*RW);

        BufferedImage bim = new BufferedImage(length, h, BufferedImage.TYPE_3BYTE_BGR);
        Graphics2D g = bim.createGraphics();
        g.setColor(Color.WHITE);
        g.fillRect(0,0, bim.getWidth(), bim.getHeight());

        int x=0;
        int RGB = Color.RED.getRGB();
        int BLUE = Color.BLUE.getRGB();
        for (int ri=0; ri<rows.size(); ri++)
        {
            int[] r = rows.get(ri);
            int[] sr = starts.get(ri);

            setRGB(bim, r,x,RGB);
            setRGB(bim, sr,x,BLUE);
            x+=RW;
        }
        return bim;
    }
}
    

