package lmu.utils;
import java.util.*;

public class PairIterator<A,B> implements Iterator<Pair<A,B>>
{
    Iterator<Map.Entry<A,B> > it=null;
    Vector<A> v1=null;
    Vector<B> v2=null;

    int i=0; 
    int j=0;

    public PairIterator(Vector<A> v1, Vector<B> v2)
    {
        this.v1=v1; this.v2=v2;
        
    }

    public PairIterator(Map<A,B> tmap)
    {
        it=tmap.entrySet().iterator();
    }

    public boolean hasNext()
    {
        if (it!=null)
        {
            return it.hasNext();
        }
        return v1!=null && v2!=null && i<v1.size() && v2.size()>0;
        
    }
    public Pair<A,B> next()
    {
        if (it!=null)
        {
            Map.Entry<A,B> e = it.next();
            return new Pair<A,B>(e.getKey(), e.getValue());
        }
        Pair<A,B> p = new Pair<A,B>(v1.get(i), v2.get(j++));
        if (j>=v2.size())
        {
            j=0; i++;
        }
        return p;
        
    }
    public void remove()
    {
        if (it!=null)
        {
            it.remove();
        }
        throw new RuntimeException("not implemented! (and will never be on vectors...)");
        
    }
}

