package lmu.utils;

import java.util.*;

public class PeakableIterator<A> implements Iterator<A>
{
    A peak;

    Iterator<A> it;

    public PeakableIterator(Iterator<A> it)
    {
        this.it=it;
    }

    public boolean hasNext()
    {
        return (peak!=null || it.hasNext());
        
    }

    public A peak()
    {
        if (peak!=null)
        {
            return peak;
        }
        if (!it.hasNext())
        {
            return null;
        }
        return peak = it.next();
    }
    public A next()
    {
        if (peak!=null)
        {
            A rv = peak;
            peak=null;
            return rv;
        }
        return it.next();
    }

    public void remove()
    {
        it.remove();
    }
}

