package lmu.utils;

import java.util.*;

public class PermutationIterator implements Iterator<Vector<Integer>>
{

    int N;
    int M;
    IncrementableVector iv;
    Vector<Integer> rv;

    public PermutationIterator(int N)
    {
        this(N,N);
    }
    public PermutationIterator(int N, int M)
    {
        this.N=N;
        this.M=M;
        rv = new Vector<Integer>();
        Vector<Integer> dimensions = new Vector<Integer>();
        for (int i=0, j=M; i<N; i++, j--)
        {
            dimensions.add(j);
            rv.add(0);
        }
        iv = new IncrementableVector(dimensions);

        
    }

    public boolean hasNext()
    {
        return iv.hasNext();
    }

    public void remove()
    {
        throw new UnsupportedOperationException();
    }

    public Vector<Integer> next()
    {
        Vector<Integer> v = iv.next();
        if (v==null)
            return v;
        
        
        Vector<Integer> numbers = new Vector<Integer>();
        for (int p=0; p<M; p++)
        {
            numbers.add(p);
        }
        for (int p = 0; p<N; p++)
        {
            int selected = v.get(p);
            rv.set(p, numbers.get(selected));
            numbers.removeElementAt(selected);
        }
        return rv;

    }
    static long fact(int n)
    {   
       
        long rv = 1;
        for (int i=2; i<=n; i++)
        {
            rv*=i;
        }
        return rv;
    }

    static long under(int k, int n)
    {   
       
        long rv = 1;
        for (int i=n-k; i<=n; i++)
        {
            rv*=i;
        }
        return rv;
    }


    public static void generate_p(Vector<Integer> v)
    {
        //Collections.sort(v);
        //Collections.reverse(v);
        int minidx=0;
        for (int i=1; i<v.size(); i++)
        {
            if (v.get(i)>=v.get(minidx))
                continue;
            
            minidx=i;
        }
        

        Vector<Integer> dimensions = new Vector<Integer>();

        Vector<Vector<Integer>> paralell = new Vector<Vector<Integer>>();

        Vector<Vector<Integer>> index_list = new Vector<Vector<Integer>>();
        for (int i=0; i<v.size(); i++)
        {
            paralell.add(new Vector<Integer>());
            Vector<Integer> tv = new Vector<Integer>();
            for (int j=0; j<v.get(i); j++)
            {
                tv.add(j);
            }
            index_list.add(tv);
            dimensions.add((minidx==i)?1:v.get(i));
        }
        
        int mindim = v.get(minidx);
                
        
        IncrementableVector iv = new IncrementableVector(dimensions);

        while (iv.hasNext())
        {
            Vector<Integer> starts = iv.next();
            
            for (int si=0; si<starts.size(); si++)
            {
                Vector<Integer> ppv = paralell.get(si);
                ppv.clear();
                int idx=starts.get(si);
                Vector<Integer> il = index_list.get(si);
                while (ppv.size()<mindim)
                {
                    if(idx==il.size())
                    {
                        idx=0;
                    }
                    ppv.add(il.get(idx));

                    idx++;
                }

            }
            System.out.println(paralell);
        }
        
    }

    public static void main2 (String args[]) 
    {
        Vector<Integer> v = new Vector<Integer>();
        for (int i=0; i<args.length; i++)
        {
            v.add(Integer.parseInt(args[i]));
        }
        
        generate_p(v);
    

    }

    static void cards1()
    {
        
        PermutationIterator pi = new PermutationIterator(4, 52);
        HashSet<Tuple> comb = new HashSet<>();
        int nstep = 0;
        while (pi.hasNext())
        {
            Vector<Integer> v = pi.next();
            Collections.sort(v);
            Tuple t = new Tuple(4);
            for (int i=0; i<4; i++)
            {
                t.set(i, v.get(i));
            }
            comb.add(t);
        }
        System.out.printf("got %d comb\n", comb.size());
        java.io.PrintWriter pw = FileUtils.getWriter("cards.txt");
        for (Tuple t : comb)
        {
            for (int j=0; j<4; j++)
            {
                if (j > 0)
                {
                    pw.printf("\t");
                }
                pw.printf("%d", (int)t.get(j));
                
            }
            pw.println();
        }

        pw.close();
    }

    static class Layout
    {
        Tuple selection;
        //Tuple4<Integer,Integer,Integer> selection;
        //Tuple3<Integer,Integer,Integer> visible;
        Integer target;

        //Tuple3 visible;

        public Layout(Tuple s, int dist)
        {
            selection = s;
            if (dist <= 4)
            {
                //look for the target card
                for (int i=0; i<4; i++)
                {
                    //int next = (i < 4) ? (int)
                    //int diff = (i==3) ? (52 + (int)s.get(0)) - (int)s.get(3)
                    //s.get(i+1)
                }
            }
        }
    }

    static void cards()
    {
        
        Vector<int[]> c = ObjectGetter.map(FileUtils.getFieldSetIterator(new java.io.File("cards.txt"), "\t"), (String sp[]) -> StringUtils.convert_int(sp));

        HashSet<Tuple> comb = new HashSet<>();

        for (int[] v : c)
        {
            Tuple t = new Tuple(4);
            for (int i=0; i<4; i++)
            {
                t.set(i,v[i]);
            }
            comb.add(t);
        }
        
        System.out.printf("got %d comb\n", comb.size());
        HashMap<Integer, HashSet<Tuple>> mind2comb = new HashMap<>();
        
        for (Tuple t : comb)
        {
            int mind = (52+(int)t.get(0)) - (int)t.get(3);
            for (int i=1; i<4; i++)
            {
                int d = (int)t.get(i) - (int)t.get(i-1);
                mind = Math.min(mind,d);
            }
            HashSet<Tuple> v = mind2comb.get(mind);
            if (v == null)
            {
                mind2comb.put(mind, v = new HashSet<>());
            }
            v.add(t);
        }
        Set<Tuple> todo = new HashSet<>();
        todo.addAll(comb);
        for (int i=1; i<4; i++)
        {
            HashSet<Tuple> h = mind2comb.get(i);
            final int l = i;
            for (Tuple t : h)
            {
                //one of them is l away from another
            }
            //todo = SetInfo.minus(todo, mind2comb.get(i));
        }
        
        System.out.printf("after one card: %d\n", todo.size());

        for (int i=1, j=0; j<6; i+=1, j++)
        {
            final int l = i;
            HashSet<Tuple> h = ObjectGetter.toSet(ObjectGetter.filter(todo, (Tuple t) -> ((int)t.get(1) - (int)t.get(0)) == l || ((int)t.get(2) - (int)t.get(1)) == l));
            todo = SetInfo.minus(todo, h);
            System.out.printf("dist %d: %d todo left: %d\n", i, h.size(), todo.size());
        }


        Set<Tuple> todo2 = new HashSet<>();
        todo2.addAll(todo);

        HashMap<Tuple, Integer> c3 = new HashMap<>();

        int[][] perms = {{0,1,2}, {0,2,1}, {1,0,2}, {1,2,0}, {2, 0, 1}, {2, 1, 0}};
        
        Vector<Tuple> todov = ObjectGetter.toVector(todo);
        
        Vector<Vector<Integer>> mappings = new Vector<>();
        HashMap<Tuple, HashSet<Tuple>> three2four = new HashMap<>();

        for (int i=0; i<todov.size(); i++)
        {
            Tuple t = todov.get(i);
            //every 4-th can be encoded with all permutations of selecting three of four
            Vector<Integer> im = new Vector<>();
            for (int j=0; j<4; j++)
            {
                
                Tuple k = new Tuple(3);
                for (int l=0, n=0; l<4; l++)
                {
                    if (l == j)
                        continue;
                    
                    k.set(n++, t.get(l));
                }
                //System.out.println("k: "+k + " t: " +t);
                for (int [] p : perms)
                {
                    Tuple k2 = new Tuple(3);
                    for (int l=0; l<3; l++)
                    {
                        k2.set(l, k.get(p[l]));
                    }
                    Integer old = c3.get(k2);
                    if (old == null)
                    {
                        old = c3.size();
                        c3.put(k2, old);
                    }
                    
                    im.add(old);

                    HashSet<Tuple> h =three2four.get(k2);
                    if (h == null)
                    {
                        three2four.put(k2, h = new HashSet<>());
                    }
                    h.add(t);
                }
                //1,2,3, 1,3,2, 2,1,3, 2,3,1, 3,1,2, 3,2,1

            }
            //System.out.printf("%d\n", w.size());
            mappings.add(im);
            
        }
        System.out.printf("got %d 3-tuple combs (check: %d) 4->3 min: %d max: %d 3->4 min: %d max: %d\n", c3.size(), three2four.size(),
                          NumUtils.min(mappings, (Vector<Integer> h) -> h.size()),
                          NumUtils.max(mappings, (Vector<Integer> h) -> h.size()),
                          NumUtils.min(three2four.values(), (HashSet<Tuple> h) -> h.size()),
                          NumUtils.max(three2four.values(), (HashSet<Tuple> h) -> h.size()));

        Vector<Map.Entry<Tuple, HashSet<Tuple>>> three2four_v = ObjectGetter.toVector(three2four.entrySet());
        NumUtils.sort(three2four_v, (Map.Entry<Tuple, HashSet<Tuple>> e) -> e.getValue().size());
        System.out.printf("tree2four sorted: %d\n", three2four_v.size());
        HashMap<Tuple, Tuple> selected_sol = new HashMap<>();
        HashMap<Tuple, Tuple> backmap = new HashMap<>();
        
        int ni=0;

        for (Map.Entry<Tuple, HashSet<Tuple>> e : three2four_v)
        {
            Vector<Tuple> v = ObjectGetter.filter(e.getValue(), (Tuple t) -> null == backmap.get(t));
            ni++;
            if (ni % 1_000 == 0)
            {
                //System.out.printf("after %d sol: %d\n", ni, selected_sol.size());
            }
            if (v.size() == 0)
                continue;
            
            //System.out.printf("%s -> %s\n", e.getKey(), v.get(0));
            selected_sol.put(e.getKey(), v.get(0));
            backmap.put(v.get(0), e.getKey());
        }
        System.out.printf("brute force: %d backmap: %d\n", selected_sol.size(), backmap.size());

        /*quicktest.gergely.Munkres m = new quicktest.gergely.Munkres();

        //m.log.setLevel("debug");
        for (int i=0; i<todov.size(); i++)
        {
            for (int j : mappings.get(i))
            {
                m.add(i,j, 1.0);
            }
            
        }
        */
        Vector<Pair<Integer,Integer>> result = new Vector<Pair<Integer,Integer>>();
        //double score = m.calculate(result);
        double score = 0.0;

        System.out.printf("score: %2.2f\n", score);
        //double weights[][] = new double[todo.size()][c3.size()];
        int sum=0;
        for (int i=1; i<15; i++)
        {
            HashSet<Tuple> v = mind2comb.get(i);
            if (v == null)
            {
                System.out.printf("%d: %d total: %d\n", i, 0, sum);
                continue;
            }
            sum+=v.size();
            System.out.printf("%d: %d total: %d\n", i, v.size(), sum);
            
            HashMap<Tuple, HashSet<Tuple>> encodings = new HashMap<>();

            for (Tuple t : v)
            {
                //check which 3-combis we could make out of the 4 cards
                Tuple best_encoding = null;
                int beste_c = Integer.MAX_VALUE;
                for (int j=0; j<4; j++)
                {
                    Tuple k = new Tuple(3);
                    for (int l=0, n=0; l<4; l++)
                    {
                        if (l == j)
                            continue;
                        
                        k.set(n++, t.get(l));
                    }
                    HashSet<Tuple> e = encodings.get(k);
                    if (e == null)
                    {
                        best_encoding = k;
                        beste_c = 0;
                        break;
                    }
                    if (best_encoding != null && beste_c <= e.size())
                        continue;
                    
                    best_encoding = k;
                    beste_c = e.size();
                    
                }
                HashSet<Tuple> e = encodings.get(best_encoding);
                if (e == null)
                {
                    encodings.put(best_encoding, e = new HashSet<>());
                }
                e.add(t);
            }
            System.out.printf("encodings: %d max: %d\n", encodings.size(), NumUtils.max(encodings.values(), (HashSet<Tuple> hs) -> hs.size()));
            //how many  we encode 

        }

        //the question is - can we assign a uniq 3-variant 
        //quicktest.gergely.BipartiteMatching bm = new quicktest.gergely.BipartiteMatching.hgAlgorithm(

    }
    public static void main (String args[]) 
    {

        cards();
        if(true)return;
        //main2(args);
        //if(1==1)return;
        int size=(args.length>0)?Integer.parseInt(args[0]):5;
        int size2=(args.length>1)?Integer.parseInt(args[1]):7;
        PermutationIterator pi = new PermutationIterator(size, size2);
        int n=0;

        System.out.printf("size should be: %d f2: %d\n",  under(size,size2), fact(size2));
        HashSet<Long> seen = new HashSet<Long>();
        while (pi.hasNext())
        {
            Vector<Integer> v = pi.next();
            //check valid
            HashSet<Integer> h = new HashSet<Integer>();
            long crc=0;
            long base=1;
            for (int i: v)
            {
                h.add(i);
                crc+=(base*i);
                base*=size2;
            }
            
            if (h.size()!=size)
            {
                throw new FRuntimeException("invalid v: %s for %d\n", v, size);
            }
            if (seen.contains(crc))
            {
                throw new FRuntimeException("got already v: %s (crc: %d) for %d\n", v, crc, size);
            }
            seen.add(crc);
            
            n++;
            boolean foundclose = false;
            for (int i=0; !foundclose && i<size; i++)
            {
                int center = 0;
                for (int  j=0; !foundclose && j<size; j++)
                {
                    if (i==j)
                        continue;
                    
                    foundclose = (Math.abs(i-j)<13);
                }
            }
            if (!foundclose)
            {
                System.err.println("error at " + v);
                return;
                                   
            }
            if (n % 10_000 == 0)
            {
                System.out.println("n: " +n +" : " +v);
            }
        }
        System.out.printf("got %d should be: %d f2: %d\n", n, under(size, size2), fact(size2));
    }
}
