package lmu.utils;

import java.util.*;
import java.io.*;

public class PositionalStringAnnot
{
    int length=0;
    Vector<StringBuffer> rows = new Vector<StringBuffer>();
    String double_fmt="%2.3f";


    public void setDoubleFmt(String dbl_fmt)
    {
        double_fmt=dbl_fmt;
    }
    public void setLength(int l)
    {
        length=l;
    }

    public void setAnnot(int pos, double intannot)
    {
        setAnnot(pos, String.format(double_fmt, intannot));
    }

    public void setAnnot(int pos, int intannot)
    {
        setAnnot(pos, ""+intannot);
    }
    public void setAnnot(int pos, String s)
    {
        if (pos>=length)
        {
            throw new RuntimeException("invalid annot, length is: "+length+" pos: "+pos);
        }
        while(s.length()>rows.size())
        {
            StringBuffer sb = new StringBuffer();
            for (int i=0; i<length; i++)
            {
                sb.append(' ');
            }
            rows.add(sb);
        }
        for (int i=0; i<s.length(); i++)
        {
            rows.get(i).setCharAt(pos, s.charAt(i));
        }
    }

    public void print(PrintWriter pw, String prefix)
    {
        for (StringBuffer sb: rows)
        {
            if (prefix!=null)
            {
                pw.print(prefix);
            }
            pw.println(sb.toString());
        }
    }

    /** appends sa onto this */
    public void concat(PositionalStringAnnot sa, String separator)
    {
        throw new RuntimeException("not yet implemented");
    }
}

