package lmu.utils;

import java.util.*;

public class PrimeGenerator
{

    static HashMap<Integer, int[]> size2primes = new HashMap<Integer, int[]>();

    public static int[] generatePrimes(int size, int start_at)
    {
        int[] rv=new int[size];
        int last=start_at;
        for (int i=0; i<size; i++)
        {
            rv[i]=generateAbove(last+1);
            last=rv[i];
        }
        return rv;
    }
    
    public static int[] getPrimes(int size)
    {
        int[] rv = size2primes.get(size);
        if (rv!=null)
            return rv;
        
        size2primes.put(size, rv=generatePrimes(size, 1000));
        return rv;
    }
    private static boolean isPrime(int i) 
    {
        if(i <= 1 ) return false;
        if(i == 2 ) return true;
        //test for all multiples of 2
        if ((i & 1 ) == 0) return false;

        //test for all multiples of 3
        if ((i %3 ) == 0) return false;
            //other wise test all odd numbers, but we are checking only for probable prime numbers of the
            // form 6K+1/6K-1 k>1;

        for(int j=6; (j*j)<=i; j+=6) 
        {
            if(i%(j-1)==0)
                return false;
            if(i%(j+1)==0)
                return false;
        }
        return true;
    }

    public static int generateAbove(int start)
    {
        int totest=start;
        while (true)
        {
            if (!isPrime(totest))
            {
                totest++;
                continue;
            }
            return totest;
        }
   }
}


