package lmu.utils;

public class RegionCoverageUpdater
{
    int start;
    int end;
    int maxpos;
    int[] c;


    public RegionCoverageUpdater(int start, int end)
    {
        this.start=start;
        this.end=end;
        maxpos=end-1;
        c=new int[end-start];

    }

    public void update(int s, int e)
    {
        s=Math.max(s,start);
        e=Math.min(e,maxpos);
        if (s>=e)
            return; //not in this region
        
        c[s-start]++;
        c[e-start]--;
    }
    
    public int[] compile()
    {
        int last=0;
        for (int i=0; i<c.length; i++)
        {
            c[i]+=last;
            last=c[i];
        }
        return c;

    }

}

