package lmu.utils;

import java.util.*;

public class RegionOverlapDetector<A>
{
    public interface CoordGetter<A>
    {
        public int get(A a);
    }
    

    int maxpos = -1;
    Overlap2DDetector od = new Overlap2DDetector();
    static Pair<Double, Double> DIM2 = Pair.create(0.0,1.0);

    public RegionOverlapDetector()
    {

    }
    public RegionOverlapDetector(Collection<A> c, CoordGetter<A> start_getter, CoordGetter<A> end_getter)
    {
        maxpos = NumUtils.max(c, (A g) -> end_getter.get(g)) + 1;
        ObjectGetter.apply(c, (A g) -> od.add(Pair.create((double)start_getter.get(g), (double)end_getter.get(g)), DIM2, g));
    }
    

    CoordGetter<A> _start_getter;
    CoordGetter<A> _end_getter;

    public void setGetters(CoordGetter<A> start_getter, CoordGetter<A> end_getter)
    {
        _start_getter = start_getter;
        _end_getter = end_getter;
    }

    public void add(A g)
    {
        add(g, _start_getter, _end_getter);
    }

    public void add(A g, CoordGetter<A> start_getter, CoordGetter<A> end_getter)
    {
        add(g, start_getter.get(g), end_getter.get(g));
    }

    public void add(A g, int start, int end)
    {
        maxpos = Math.max(maxpos, end + 1);
        od.add(Pair.create((double)start, (double)end), DIM2, g);
    }
    /*public RegionOverlapDetector(Iterator<A> c, CoordGetter<A> start_getter, CoordGetter<A> end_getter)

    {
        maxpos = NumUtils.max(c, (A g) -> end_getter.get(g)) + 1;
        ObjectGetter.apply(c, (A g) -> od.add(Pair.create((double)start_getter.get(g), (double)end_getter.get(g)), DIM2, g));
    }
    */

    public Iterator<A> getOverlapping(Integer start, Integer end)
    {
        return ObjectGetter.getTransformedIterator(
                    od.getOverlaps(
                            (start == null) ? 0.0 : start.doubleValue(),
                            (end == null) ? (double)maxpos : end.doubleValue(),
                             DIM2.getFirst().doubleValue(),
                            DIM2.getSecond().doubleValue(),
                            null
                            ).iterator(),
                    (Object o) -> (A)o);

    }

    public int getMaxpos()
    {
        return maxpos;
    }
}

