
package lmu.utils;

import java.io.File;
/**
 * @author pesch, wolf
 * This method need an File where the replacement is defined. One is stored /web/conf/UnicodeReplacement.csv.
 */
import java.util.HashMap;

public class StringDecoder
{

    private HashMap<Integer, String> characterMapping;

    public StringDecoder(File replacements)
    {

        // http://unicodelookup.com
        characterMapping = new HashMap<Integer, String>();
        boolean hasTitle = true;
        characterMapping = FileUtils.readMap(replacements, ",", 0, 1, "int", "string", hasTitle);

    }

    public StringDecoder()
    {
        characterMapping = MapBuilder.build(913, "Alpha").
                           add(914, "Beta").
                           add(915, "Gamma").
                           add(916, "Delta").
                           add(917, "Epsilon").
                           add(918, "Zeta").
                           add(919, "Eta").
                           add(920, "Theta").
                           add(921, "Iota").
                           add(922, "Kappa").
                           add(923, "Lambda").
                           add(924, "Mu").
                           add(925, "Nu").
                           add(926, "Xi").
                           add(927, "Omicron").
                           add(928, "Pi").
                           add(929, "Rho").
                           add(931, "Sigma").
                           add(932, "Tau").
                           add(933, "Upsilon").
                           add(934, "Phi").
                           add(935, "Chi").
                           add(936, "Psi").
                           add(937, "Omega").
                           add(945, "alpha").
                           add(946, "beta").
                           add(947, "gamma").
                           add(948, "delta").
                           add(949, "epsilon").
                           add(950, "zeta").
                           add(951, "eta").
                           add(952, "theta").
                           add(953, "iota").
                           add(954, "kappa").
                           add(955, "lambda").
                           add(956, "mu").
                           add(957, "nu").
                           add(958, "xi").
                           add(959, "omicron").
                           add(960, "pi").
                           add(961, "rho").
                           add(962, "sigmaf").
                           add(963, "sigma").
                           add(964, "tau").
                           add(965, "upsilon").
                           add(966, "phi").
                           add(967, "chi").
                           add(968, "psi").
                           add(969, "omega").
                           add(61667, "gamma").
                           add(181, "mu").
                           add(160, " ").
                           add(215, "x").
                           add(8242, "'").
                           add(8804, "<=").
                           add(8805, ">=").
                           add(8764, "~").
                           add(8758, ":").
                           add(183, ".").
                           add(8212, "-").
                           add(8722, "-").
                           add(8211, "-").
                           add(177, "~").
                           add(8594, "->").
                           add(8727, "*").
                           add(197, "A").
                           add(239, "i").
                           add(183, ".").
                           add(196, "Ae").
                           add(214, "Oe").
                           add(220, "Ue").
                           add(228, "ae").
                           add(252, "ue").
                           add(246, "oe").
                           add(96, "'").
                           add(180, "'").
                           add(714, "'").
                           add(733, "\"").
                           add(758, "\"").
                           add(8217, "'").
                           add(769, "'").
                           add(8216, "\"").
                           add(757, "\"").
                           add(64, "at").
                           add(223, "ss").
                           add(126,"~").
                           add(60,"<").
                           add(62,">").
                           add(8202, " ")
                           .add(231, "c")
                           //Latin signs
                           .add(300,"A")
                           .add(301, "A")
                           .add(302 , "A")
                           .add(303 , "A")
                           .add(304, "Ae")
                           .add(305, "A")
                            .add(306, "Ae")
                            .add(307, "C")
                            .add(310 , "E")
                            .add(311 , "E")
                            .add(312 , "E")
                            .add(313 , "E")
                            .add(314 , "I")
                            .add(315 , "I")
                            .add(316 , "I")
                            .add(317 , "I")
                            .add(320 , "D")
                            .add(321 , "N")
                            .add(322 , "O")
                            .add(323 , "O")
                            .add(324 , "O")
                            .add(325 , "O")
                            .add(326 , "Oe")
                            .add(330 , "O")
                            .add(331 , "U")
                            .add(332 , "U")
                            .add(333 , "U")
                            .add(334 , "Ue")
                            .add(335 , "Y")
                            .add(337 , "ss")
                            .add(340 , "a")
                            .add(341 , "a")
                            .add(342 , "a")
                            .add(343 , "a")
                            .add(344 , "ae")
                            .add(345 , "a")
                            .add(346 , "ae")
                            .add(347 , "c")
                            .add(350 , "e")
                            .add(351 , "e")
                            .add(352 , "e")
                            .add(353 , "e")
                            .add(354 , "i")
                            .add(355 , "i")
                            .add(356 , "i")
                            .add(357 , "i");

                           
                           
                           
                           


    }

    static java.nio.charset.CharsetEncoder asciiEncoder = java.nio.charset.Charset.forName("US-ASCII").newEncoder(); // or
    // "ISO-8859-1"
    // for
    // ISO
    // Latin
    // 1

    public static boolean isPureAscii(String v)
    {
        return asciiEncoder.canEncode(v);
    }

    public static boolean isAscii(char ch)
    {
        return asciiEncoder.canEncode(ch);
    }

    public static int numberOfNonAsciiChars(String v)
    {
        int appearances = 0;
        for (int i = 0; i < v.length(); i++)
        {

            if (!asciiEncoder.canEncode(v.charAt(i)))
            {
                appearances = appearances + 1;

            }
        }
        return appearances;
    }
    public static int numberOfNonAsciiChars(StringBuffer v)
    {
        int appearances = 0;
        for (int i = 0; i < v.length(); i++)
        {

            if (!asciiEncoder.canEncode(v.charAt(i)))
            {
                appearances = appearances + 1;

            }
        }
        return appearances;
    }

    /** @param str
     * @return Modified String */
    public String decode(String str)
    {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < str.length(); i++)
        {
            if (asciiEncoder.canEncode(str.charAt(i)))
            {
                sb.append(str.charAt(i));
                continue;
            }
           
            String replacement = characterMapping.get((int) str.charAt(i));
            if (replacement == null)
            {
                // skip
                continue;
            }
            sb.append(replacement);
        }
        return sb.toString();
    }

    public static void main(String[] args) throws Exception
    {

        if (args.length > 0)
        {
            for (String f : args)
            {
                ObjectGetter.apply(FileUtils.getLineIterator(new File(f)),
                                   (String line) ->
                                   {
                                       if (isPureAscii(line))
                                           return;

                                       System.out.println("not only ascii: " + line + " file: " + f);
                                   }
                                  );
            }

            return;
        }
        StringDecoder sd = new StringDecoder();// new File(args[0]));
        System.out.println(sd.decode(" suggesting that miR-126’s atheroprotective functions may be exploited by ß äöü @ \"therapeutic\" mimetics or miR-126–loaded microparticles. The CXCR4- and CXCL12-related roles of neutrophil homeostasis, and endothelial homeostasis, as well as the involvement of miR-126 and its targets in atheroprotection emphasize the need to address these axes in cell-type–specific conditional knockouts."));

    }


}
