package lmu.utils;

    
import java.util.*;
import java.util.regex.Pattern;
import java.io.*;

public class StringUtils
{

    public static StringBuffer initBuffer(int n)
    {
        StringBuffer sb = new StringBuffer();
        ObjectGetter.apply(IteratorUtils.getIntIterator(0, n), (Integer idx) -> sb.append(' '));
        return sb;
    }
    public static String multiply(String s, int n)
    {
        StringBuffer sb = new StringBuffer();
        ObjectGetter.apply(IteratorUtils.getIntIterator(0, n), (Integer idx) -> sb.append(s));
        return sb.toString();
    }
    static int cp(String s1, String s2, int start1, int start2, int step)
    {
        int cp_l = 0;
        final int L1 = s1.length();
        final int L2 = s2.length();

        for (int i=start1, j=start2; i>=0 && j>=0 && i<L1 && j<L2; i+=step, j+=step, cp_l++)
        {
            if (s1.charAt(i) == s2.charAt(j))
                continue;
            
            break;
        }
        return cp_l;

    }
    public static Vector<String> slice(String[] sp, int start)
    {
        return slice(sp,start);
    }

    public static Vector<String> slice(String[] sp, int start, int end)
    {
        if (end < 0 )
        {
            end = sp.length + end;
        }
        return ObjectGetter.map(IteratorUtils.getIntIterator(start, end), (Integer idx) -> sp[idx]);
        
    }
    public static String lcp(String s1, String s2)
    {
        return s1.substring(0, cp(s1,s2, 0, 0, 1));
        
    }

    public static String lcs(String s1, String s2)
    {
        
        return s1.substring(s1.length()-1-cp(s1,s2, s1.length()-1, s2.length()-1, -1));
    }

    public static Pair<Integer,Integer> getEditedPart(String old, String newstr)
    {
        String prefix = lcp(old, newstr);
        if (prefix.length() == old.length())
        {
            return new Pair<Integer,Integer>(old.length(), newstr.length());
        }
        
        String suffix = lcp(old, newstr);

        if (suffix.length() == old.length())
        {
            return new Pair<Integer,Integer>(0, newstr.length() - old.length());
        }
        if (prefix.length() + suffix.length() == newstr.length()) //deleted something
        {
            return new Pair<Integer,Integer>(prefix.length(), prefix.length());
        }

        return new Pair<Integer,Integer>(prefix.length(), newstr.length() - suffix.length());
    }
    public static HashSet<Character> buildChrSet(String s)
    {
        return buildChrSet(s.toCharArray());
    }
    public static HashSet<Character> buildChrSet(char ... chrs)
    {
        HashSet<Character> hs = new HashSet<>();

        for (char ch : chrs)
        {
            hs.add(ch);
        }
        return hs;
    }

    
    public static HashSet<String> buildSet(String ... strings)
    {
        HashSet<String> hs = new HashSet<>();

        for (String s : strings)
        {
            hs.add(s);
        }
        return hs;
    }
    public static String[] concatArrays(String[] ... arrays)
    {
        int nalength = 0;
        for (String[] s : arrays)
        {
            nalength+=s.length;
        }
        String[] rv =new String[nalength];
        
        int idx=0;
        for(String[] s: arrays)
        {
            for (int i=0; i<s.length; i++, idx++)
            {
                rv[idx]=s[i];
            }
        }
        return rv;
    }
        
    public static String[] concatArrays(String[] a, String ... toextend)
    {
        final int alength=(a==null)?0:a.length;
        String[] rv =new String[alength+toextend.length];
        if (a!=null)
        {
            
            for (int i=0; i<a.length; i++)
            {
                rv[i]=a[i];
            }
        }
        
        for (int i=alength, j=0; j<toextend.length; i++, j++)
        {
            rv[i]=toextend[j];
        }
        return rv;
    }

    public static Vector<String> toVector(String ... sc)
    {
        Vector<String> rv = new Vector<String>();
        for (String s : sc)
        {
            rv.add(s);
        }
        return rv;

    }
    
    public static String[] convert(String ... sc)
    {
        return sc;
    }

    /*** for zkoss... */
    public static String[] convert2(String s1, String s2)
    {
        return convert(s1,s2);
    }
    
    public static String[] convert3(String s1, String s2, String s3)
    {
        return convert(s1,s2, s3);
    }

    public static String[] convert4(String s1, String s2, String s3, String s4)
    {
        return convert(s1,s2, s3, s4);
    }

    public static String[] convert(Collection<String> s)
    {
        String[] rv = new String[s.size()];
        int idx=0;
        for (String st: s)
        {
            rv[idx++]=st;
        }
        return rv;
    }
    
    public static String join(String joiner, String [] v, int start)
    {
        return join(joiner, new CollectionIterator<String>(v, start));
    }
    public static String join(String joiner, String [] v, int start, int end)
    {
        return join(joiner, new CollectionIterator<String>(v, start, end));
    }
    
    public static String joinObjects(String joiner, Collection v)
    {
        return joinObjects(joiner,v,null);
    }
    public static String joinObjects(String joiner, Collection v, String fmt)
    {
        Vector<String> converted = new Vector<String>();
        for (Object o : v)
        {
            converted.add((fmt==null)? ""+o : String.format(fmt, o));
        }
        return join(joiner,converted);
    }
    public static String join(String joiner, Object ... v)
    {
        Vector<String> converted = new Vector<String>();
        for (Object o : v)
        {
            converted.add(""+o);
        }
        return join(joiner,converted);
    }
    public static String join(String joiner, String ... v)
    {
        return join(joiner, new CollectionIterator<String>(v));
    }
    public static String join(String joiner, Collection<String> v)
    {
        return join(joiner, new CollectionIterator<String>(v));
    }

    public static String join(String joiner, Iterator sit)
    {
        StringBuffer sb = new StringBuffer();
        while (sit.hasNext())
        {
            if (sb.length()>0)
            {
                sb.append(joiner);
            }
            sb.append(""+sit.next());
        }
        return sb.toString();
    }

    public static String join(String s, Vector<Integer> v)
    {
        if (v==null)
        {
            return "";
        }
        return join(s, new CollectionIterator(v));
    }
    public static String join(String s, int [] v)
    {
        if (v==null)
        {
            return "";
        }
        return join(s, CollectionIterator.getIterator(v));
    }
    public static String join(String s, double [] v)
    {
        if (v==null)
        {
            return "";
        }
        return join(s, CollectionIterator.getIterator(v));
    }

    public static Vector<Integer> convert_int_vector(String s, String p)
    {
        return ObjectGetter.toVector(convert_int(s, p));
    }

    public static Vector<Integer> convert_int_vector(String s, Pattern p)
    {
        return ObjectGetter.toVector(convert_int(s, p));
    }

    public static int[] convert_int(String s, Pattern p)
    {
        return convert_int(p.split(s));
    }
    public static int[] convert_int(String s, String regex)
    {
        return convert_int(s.split(regex));
    }
    public static int[] convert_int(String[] sp)
    {
        if (sp.length==1 && sp[0].length()==0)
        {
            return new int[0];
        }
        int rv[]=new int[sp.length];
        for (int i=0; i<sp.length; i++)
        {
            rv[i]=Integer.parseInt(sp[i]);
        }
        return  rv;
    }
    public static float[] convert_float(String[] sp)
    {
        if (sp.length==1 && sp[0].length()==0)
        {
            return new float[0];
        }
        float rv[]=new float[sp.length];
        for (int i=0; i<sp.length; i++)
        {
            rv[i]=Float.parseFloat(sp[i]);
        }
        return rv;
    }
    public static double[] convert_double(String[] sp)
    {
        if (sp.length==1 && sp[0].length()==0)
        {
            return new double[0];
        }
        double rv[]=new double[sp.length];
        for (int i=0; i<sp.length; i++)
        {
        	//System.out.println(sp[i]);
            rv[i]=Double.parseDouble(sp[i]);
        }
        return rv;
    }

    public static long[] convert_long(String[] sp)
    {
        long rv[]=new long[sp.length];
        for (int i=0; i<sp.length; i++)
        {
            rv[i]=Long.parseLong(sp[i]);
        }
        return rv;
    }

    public static String repeat(String s, int times)
    {
        StringBuffer sb = new StringBuffer();
        for (int i=0; i<times; i++)
        {
            sb.append(s);
        }
        return sb.toString();
        
    }


    public static String repeat(char s, int times)
    {
        StringBuffer sb = new StringBuffer();
        for (int i=0; i<times; i++)
        {
            sb.append(s);
        }
        return sb.toString();
        
    }

    public static String generateRandomString(int length)
    {
        char chars[]=new char[('z'-'a')+1];
        for (char i='a'; i<='z'; i++)
        {
            chars[i-'a']=i;
        }
        StringBuffer rndm = new StringBuffer();

        for (int i=0; i<length; i++)
        {
            rndm.append(chars[(int)(Math.random()*chars.length)]);
        }
        return rndm.toString();

    }

    public static String reverse(String s)
    {
        StringBuffer sb = new StringBuffer();
        sb.append(s);
        return sb.reverse().toString();
    }


    public static String readString(byte[] data, boolean gzipped)
    {
        return readString(data, 0, data.length, gzipped);
    }
    
    public static  String readString(byte[] data, int offset, int length, boolean gzipped)
    {
        InputStream is = new ByteArrayInputStream(data, offset, length);
        try
        {
            
            if (gzipped)
            {
                is = new java.util.zip.GZIPInputStream(is);
            }
            StringBuffer sb = new StringBuffer();
            BufferedReader bfr = new BufferedReader(new InputStreamReader(is));
            int c = -1;
            while (-1 != (c = bfr.read()))
            {
                sb.append((char)c);
            }
            return sb.toString();
        }
        catch(IOException ie)
        {
            throw new FRuntimeException("i/o error: %s while reading from data zipped: %s", ie, ie.getMessage(), gzipped);
        }
    }

    public static String removeNonAlphaNumeric(String s)
    {
        StringBuffer sb = new StringBuffer();
        for (int i=0; i<s.length(); i++)
        {
            char ch = s.charAt(i);
            if (!Character.isDigit(ch) && !Character.isLetter(ch))
                continue;
            
            sb.append(ch);
        }
        return sb.toString();
    }

    public static int getIndex(String[] sp, String s)
    {
        if (s == null)
            return -1;
        
        
        for (int i = 0; i < sp.length; i++)
        {
            if (sp[i] == null || !sp[i].equals(s))
                continue;
            
            return i;
        }
        return -1;
    }

    public interface StringFormatter<A>
    {
        public String getStr(A a);
    }

    public static<A> String join(String joiner, Collection<A> c, StringFormatter<A> sf)
    {
        return joinObjects(joiner, ObjectGetter.map(c, (a) -> sf.getStr(a)));
    }

    public static String getSorted(String s)
    {
        Vector<Character> v = ObjectGetter.toVector(s.toCharArray());
        Collections.sort(v);
        StringBuffer sb = new StringBuffer();
        ObjectGetter.apply(v, (c) -> sb.append(c));
        return sb.toString();
    }
}
