package lmu.utils;

import java.util.*;

public class TupleMapping<A,B> 
{
    HashMap<Tuple<A>, B> data = new HashMap<Tuple<A>, B>();
    

    Tuple<A> lookup = null;
    ReflectedObject[] refobjs;
    String[] defs;
    Object[] key;

    public TupleMapping(ReflectedObject ... fields_refobjs)
    {
        refobjs=fields_refobjs;
    }
    
    public TupleMapping(String ... fields)
    {
        defs=fields;
    }

    
    public Object[] getValues(A data)
    {
        if (refobjs==null)
        {
            //build by fielddef
            refobjs=new ReflectedObject[defs.length];
        }
        if (key==null)
        {
            key=new Object[refobjs.length];
            lookup=new Tuple(key.length);
        }
        for (int i=0; i<refobjs.length; i++)
        {
            key[i]=refobjs[i].get(data);
        }
        return key;
    }

    public void put(A a, B value)
    {
        put(a,value,true);
    }
    public void put(A a, B value, boolean saveKey)
    {
        Object[] values = getValues(a);
        Tuple t = new Tuple(values.length);
        if (saveKey)
        {
            t.setValue(a);
        }
        

        for (int i=0; i<values.length; i++)
        {
            t.set(i,values[i]);
        }
        
        data.put(t, value);
        
        
    }
    
    public B _get(A a, boolean remove)
    {
        Object[] values = getValues(a);

        for (int i=0; i<values.length; i++)
        {
            lookup.set(i,values[i]);
        }
        B b=data.get(lookup);
        if (b!=null && remove)
        {
            
            data.remove(lookup);
        }
        return b;

    }


    public B get(A a)
    {
        return _get(a,false);
    }


    public int size()
    {
        return data.size();
    }

    public boolean isEmpty()
    {
        return size()==0;
    }
    
    public boolean containsKey(A key)
    {
        return get(key)!=null;
    }

    public boolean containsValue(B value)
    {
        return data.containsValue(value);
    }

    
    
    public B remove(A key)
    {
        return _get(key,true);
    }


    public void clear()
    {
        data.clear();
    }

    public Collection<B> values()
    {
        return data.values();
    }
}

