package lmu.utils;
import java.util.*;

public class UPair<A> extends Pair<A,A>
{
    public UPair(A a1, A a2)
    {
        super(a1,a2);
    }

    static public<A>  UPair<A> createU(A a1, A a2)
    {
        return new UPair<A>(a1, a2);
    }


    static public<A extends Comparable>  UPair<A> createUSorted(A a1, A a2)
    {
        A _a1 = (a1.compareTo(a2) <= 0) ? a1 : a2;
        A _a2 = (a1.compareTo(a2) <= 0) ? a2 : a1;
        return new UPair<A>(_a1, _a2);
    }

    public A get(boolean first)
    {
        return (first) ? getFirst() : getSecond();
    }

    static public<A> UPair<A> swapU(UPair<A> p)
    {
        return createU(p.getSecond(), p.getFirst());
    }

    static public<A> Vector<A> reduceFirstU(Vector<UPair<A>> v)
    {
        return ObjectGetter.map(v, (UPair<A> p) -> p.getFirst());
    }

    static public<A> Vector<A> reduceSecondU(Vector<UPair<A>> v)
    {
        return ObjectGetter.map(v, (UPair<A> p) -> p.getSecond());
    }

    public void set(int idx, A a)
    {
        if (idx == 0)
        {
            setFirst(a);
            return;
        }
        setSecond(a);
    }
    public boolean equals(UPair<A> up)
    {
        for (int i=0; i<2; i++)
        {
            A a1 = get(i == 0);
            A a2 = up.get(i == 0);
            if (a1 == null && a2 == null)
                continue;

            if (a1 == null || a2 == null)
                return false;
            
            if (!a1.equals(a2))
                return false;
        }
        
        return true;
    }
}
    