package lmu.utils;

import java.util.HashMap;

import org.jdom.Element;

public abstract class  XmlSerializer extends Serializer
{
    public static  final String SERIALIZER_ATTRIB="serializer";


    abstract protected void serialize_object(Element e, Object o);

    public static void serialize(Element e, Class serializer, Object o)
    {
        getSerializer(serializer).serialize(e,o);
    }

    
    
    public static XmlSerializer getSerializer(Class clazz)
    {
        return getSerializer(clazz.getName());

    }

    static XmlSerializer getSerializer(String classname)
    {
        return (XmlSerializer) _getSerializer(classname);
    }
    public void serialize(Element e, Object o)
    {
        e.setAttribute(SERIALIZER_ATTRIB, this.getClass().getName());
        serialize_object(e,o);
    }
    abstract protected Object deserialize_object(Element e);


    static HashMap<String, XmlSerializer> cname2serializer = new HashMap<String, XmlSerializer>();


    public static Object deserialize(Element e)
    {
        String classname = XMLUtils.getAttrib(e, SERIALIZER_ATTRIB, null, true);
        XmlSerializer deser = cname2serializer.get(classname);
        if (deser==null)
        {
            try
            {
                deser = (XmlSerializer)Class.forName(classname).newInstance();
                cname2serializer.put(classname, deser);
            }
            catch(Exception ex)
            {
                throw new RuntimeException("error:"+ex.getMessage()+" while looking for deserializer for "+classname, ex);
            }

        }
        return deser.deserialize_object(e);
        
    }
}

