package lmu.utils.filter;

import java.util.*;
import lmu.utils.*;

public class FlagFilter
{
    //String header; 
    String header;
    FileUtils.StringSplitter splitter;
    HashSet<String> flags = new HashSet<>();
    boolean include;

    public boolean filterValue(String v)
    {
        if (flags.size() == 0)
            return true;
        
        if (splitter == null)
            return (include) ? flags.contains(v) : !flags.contains(v);
        
        Set<String> ov = SetInfo.intersect(flags, ObjectGetter.toSet(splitter.split(v)));
        return (include) ? ov.size() > 0 : ov.size() == 0;
    }

    public boolean filter(Map<String, ReflectedObject> n2ref, Object o)
    {
        if (flags.size() == 0)
            return true;
        return filterValue("" + n2ref.get(header).get(o));
    }

    public boolean filter(ObjectGetter og)
    {
        if (flags.size() == 0)
            return true;
        return filterValue(og.getString(header));
        
    }


    public FlagFilter(String splitter, boolean include)
    {
        this(null, splitter, include);
    }

    public FlagFilter(String h, String splitter, boolean include)
    {
        this.header = h;
        this.splitter = (splitter == null) ? null : FileUtils.getRecordSplitter(splitter);
        this.include = include;
        
    }

    public void changeFlag(String s, boolean b)
    {
        ObjectGetter.decide(b, () -> addFlag(s), () -> removeFlag(s));
    }

    public void addFlag(String s)
    {
        flags.add(s);
    }

    public void removeFlag(String s)
    {
        flags.remove(s);
    }


    public static boolean filter(Collection<FlagFilter> filters, Map<String,ReflectedObject> n2ref, Object o)
    {
        for (FlagFilter f: filters)
        {
            if (!f.filter(n2ref, o))
                return false;
        }
        return true;
    }

    public static boolean filter(Collection<FlagFilter> filters, ObjectGetter og)
    {
        for (FlagFilter f: filters)
        {
            if (!f.filter(og))
                return false;
        }
        return true;
    }
    
}

