package lmu.utils.index;

import java.io.*;
import java.util.*;
import lmu.utils.*;

public class BitSetIndex extends DoubleRAFIndex<BitSet>
{

    public static BitSet readBS(int idx, RandomAccessFile raf) throws IOException
    {
        try
        {
            
            int nbytes = raf.readInt();
            byte[] data = new byte[nbytes];
            raf.read(data);
                    
            InputStream is = new java.util.zip.GZIPInputStream(new ByteArrayInputStream(data));
    
            ObjectInputStream ois = new ObjectInputStream(is);
            return (BitSet) ois.readObject();
        }
        catch(ClassNotFoundException nfe)
        {
            throw new FRuntimeException("internal error (bitset class not found: %s)", nfe, nfe.getMessage());
        }
    }

    public static void writeBS(int idx, RandomAccessFile raf, BitSet data) throws IOException
    {
        ByteArrayOutputStream baos2 = new ByteArrayOutputStream();
        java.util.zip.GZIPOutputStream go = new java.util.zip.GZIPOutputStream(baos2);
        ObjectOutputStream oos2 = new ObjectOutputStream(go);
        oos2.writeObject(data);
        oos2.close();
    
        byte[] bytes = baos2.toByteArray();
        raf.writeInt(bytes.length);
        raf.write(bytes);
    }

    public BitSetIndex(File outfile)
    {
        super(outfile, (int idx, RandomAccessFile raf) -> readBS(idx,raf), 
                (int idx2, RandomAccessFile raf2, BitSet data) -> BitSetIndex.writeBS(idx2,raf2, data));
    }
    

    public static BitSetIndex get(File f)
    {
        return (f == null || !f.exists()) ? null : new BitSetIndex(f);
    }
     
}

