package lmu.utils.obo;
import lmu.utils.*;

public enum OboField
{
    //Term fields
    ID("id"),
    NAME("name"),
    NAMESPACE("namespace"),
    ANONYMOUS("is_anonymous"),
    ALT_ID("alt_id"),
    DEF("def"),
    COMMENT("comment"),
    SUBSET("subset"),
    SYNONYM("synonym"),
    EXACT_SYN("exact_synonym"),
    NARROW_SYN("narrow_synonym"),
    BROAD_SYN("broad_synonym"),
    XREF("xref"),
    XREF_ANALOG("xref_analog"),
    XREF_UNK("xref_unk"),
    IS_A("is_a"),
    INTERSECTION("intersection_of"),
    UNION("union_of"),
    DISJOINT("disjoint_from"),
    RELATIONSHIP("relationship"),
    OBSOLETE("is_obsolete"),
    REPLACED("replaced_by"),
    CONSIDER("consider"),
    USE_TERM("use_term"),
    CREATOR("created_by"),
    DATE("creation_date"),
    //Instance fields
    PROPERTY_VALUE("property_value"),
    INSTANCE_OF("instance_of"),
    //Typedef fields
    DOMAIN("domain"),
    RANGE("range"),
    INVERSE("inverse_of"),
    TRANSITIVE_OVER("transitive_over"),
    CYCLIC("is_cyclic"),
    REFLEXIV("is_reflexive"),
    SYMMETRIC("is_symmetric"),
    ANTISYMMETRIC("is_anti_symmetric"),
    TRANSITIVE("is_transitive"),
    METADATA("is_metadata_tag")
    ;
    String name;
    OboField(String name)
    {
        this.name=name;
        EnumGetter.add(name, this);
    }

    public static OboField get(String name)
    {
        return(OboField) EnumGetter.get(name);
    }

    public String getName()
    {
        return name;
    }
}


