package lmu.utils.plotting;

import java.awt.Paint;
import java.awt.Stroke;

import lmu.utils.*;

public class AwtGraphics implements DGraphics 
{
    public java.awt.Graphics2D g2;
    java.awt.Font font;

    java.awt.image.BufferedImage bim = null;

    public AwtGraphics()
    {
        
    }

    public AwtGraphics(java.awt.Graphics2D g2)
    {
        this.g2=g2;
    }

    public void setSize(int width, int height)
    {
        //do nothing
        java.awt.image.BufferedImage  bim = ImageUtils.getWhiteImage(width,height);
        g2 = bim.createGraphics();
        
    }

    public java.awt.Color getColor()
    {
        return g2.getColor();
    }

    public java.awt.image.BufferedImage getImage()
    {
        return bim;
    }

    public void setFont(String name, int height)
    {
        java.awt.Font f  = (font!=null)?font:g2.getFont();
        f = (name==null) ? f :java.awt.Font.getFont(name);
        
        if ( f == null)
        {
        	font = new java.awt.Font(name,java.awt.Font.PLAIN,height);
        }else
        {
        	font = f.deriveFont((float)height);
    	}
        
        g2.setFont(font);
    }
    public void setColor(java.awt.Color c)
    {
        g2.setColor(c);
    }
    public void drawString(String s, int x, int y)
    {
        g2.drawString(s,x,y);
    }

    public int getFontHeight()
    {
        return lmu.utils.ImageUtils.getDrawnTextDimension(g2, "a").getSecond();
    }

    public void drawLine(int startx, int starty, int endx, int endy)
    {
        g2.drawLine(startx,starty,endx,endy);
    }


    public void fillRect(int x, int y, int width, int height)
    {
        g2.fillRect(x,y,width,height);
    }
    public void drawRect(int x, int y, int width, int height)
    {
        g2.drawRect(x,y,width,height);
    }

    public void dispose()
    {
        g2.dispose();
    }

    public int getTextWidth(String text)
    {
        return ImageUtils.getDrawnTextDimension(g2,text).getSecond();
    }

    @Override
    public void setStroke(java.awt.Stroke stroke) {
        g2.setStroke(stroke); 
    }

    @Override
    public void setPaint(Paint paint) {
        g2.setPaint(paint);
    }
    
}

