package lmu.utils.plotting;


import lmu.utils.*;
import lmu.utils.swing.*;
import java.beans.*;
import lmu.utils.ImageUtils.ImagePanel;
import java.awt.image.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import org.jdom.*;

public class DataPicturePane extends HeaderedPicturePane implements java.awt.event.MouseListener, java.awt.event.MouseMotionListener,
                                                            SliceImageDrawer
{


    void showAt(MouseEvent e)
    {
        int x=e.getX();
        int y=e.getY();

        
                           
        double value = header.getClicked(y);
        //System.out.println("x: "+x+"y: "+y+": "+value);
        data_pane.getPanel().setToolTipText(String.format(Locale.UK, "%2.3f", value));
        //data_pane.getPanel()
    }
    public void mouseDragged(MouseEvent e)
    {
    }

    public void mouseMoved(MouseEvent e)
    {
        showAt(e);
    }

    public void mouseClicked(MouseEvent e)
    {
        showAt(e);
        notifyListeners(e);
    }
    
    /**
     * Invoked when a mouse button has been pressed on a component.
     */
    public void mousePressed(MouseEvent e)
    {
    }
    
    /**
     * Invoked when a mouse button has been released on a component.
     */
    public void mouseReleased(MouseEvent e)
    {
    }
    
    /**
     * Invoked when the mouse enters a component.
     */
    public void mouseEntered(MouseEvent e)
    {
        showAt(e);
        
        
    }
    
    /**
     * Invoked when the mouse exits a component.
     */
    public void mouseExited(MouseEvent e)
    {
    }

    public final static String ELEM_NAME="datapane";
    Object userObject=null;
    PlotYAxisImage header = null;
    Vector<DataPlot> data = new Vector<DataPlot>();
    Vector<Boolean> data_visible = new Vector<Boolean>();
    int data_width=0;
    Iterator<Color> cit = ColorManager.getColorIterator();
    
    JMenuBar menubar = null;
    JMenu visibility = new JMenu("show/hide");
    Vector<JMenuItem> visible_items = new Vector<JMenuItem>();


    public PlotYAxisImage getHeaderPlot()
    {
        return header;
    }
    
    public class ConfigureDialog extends JDialog
    {
        JCheckBox logscale = new JCheckBox();

        JTextArea plot_width = new JTextArea();

        JTextArea min_value = new JTextArea();
        JTextArea max_value = new JTextArea();

        public ConfigureDialog()
        {
            super();
            JPanel jp = new JPanel();
            add(jp);

            
            logscale.setText("logscale");
            logscale.setSelected(header.isLogScale());

            min_value.setText(""+header.getMinValue());
            max_value.setText(""+header.getMaxValue());
            
            jp.add(logscale);
            jp.add(new JLabel("minval:"));
            jp.add(min_value);
            jp.add(new JLabel("maxval:"));
            jp.add(max_value);

            jp.add(new JLabel("plot width"));
            plot_width.setText(""+header.getHeight());
            jp.add(plot_width);

            setModal(true);
            pack();



        }

    }
    public void configure()
    {
        ConfigureDialog cd = new ConfigureDialog();
        cd.setVisible(true);
        
        header.setLogScale(cd.logscale.isSelected());
        int old_height = header.getHeight();
        try
        {
            header.setHeight(Integer.parseInt(cd.plot_width.getText()));
        }
        catch(NumberFormatException nfe)
        {
        }

        try
        {
            header.setMaxValue(Double.parseDouble(cd.max_value.getText()));
        }
        catch(NumberFormatException nfe)
        {
        }

        try
        {
            header.setMinValue(Double.parseDouble(cd.min_value.getText()));
        }
        catch(NumberFormatException nfe)
        {
        }

        
        update();

        if (old_height!=header.getHeight())
        {
            notifyListeners();
        }

    }
    public void setVisible(int dpi)
    {

        if (dpi<0)
        {
            for (int i=0; i<data_visible.size(); i++)
            {
                data_visible.set(i, true);
                visible_items.get(i).setText("hide"+" "+data.get(i).getName());
            }
            
        }
        else
        {
            
    
            boolean nv = !data_visible.get(dpi);
            
            data_visible.set(dpi, nv);
    
            visible_items.get(dpi).setText(((nv)?"hide":"show")+" "+data.get(dpi).getName());
        }
        int divloc=getDividerLocation();
        update();
        setDividerLocation(divloc);
    }
    public void updateMenu()
    {
        visibility.removeAll();
        JMenuItem jmi = new JMenuItem("show all");
        jmi.addActionListener(new ReflectedObjectListener(new ReflectedObject("setVisible", -1), this));
        visibility.add(jmi);
        for (int i=0; i<data.size(); i++)
        {
            DataPlot dp = data.get(i);
            jmi = new JMenuItem("hide "+dp.name);
            jmi.addActionListener(new ReflectedObjectListener(new ReflectedObject("setVisible", i), this));
            visibility.add(jmi);
            visible_items.add(jmi);

        }
    }
    public void setMenuBar(JMenuBar menubar)
    {
        this.menubar=menubar;
        
        menubar.add(visibility);

        JMenuItem jmi = new JMenuItem("configure");

        jmi.addActionListener(new ReflectedObjectListener(new ReflectedObject("configure()"), this));

        menubar.add(jmi);
        
    }
    public DataPicturePane(DataPicturePane parent, ZoomedCoordinateConverter zcc, DataAggregator.TYPE aggreg_type)
    {
        super(parent.name, parent.userObject);
        header=parent.header;
        data_width=zcc.getZoomedLength();
        cit = parent.cit;
        data_visible=parent.data_visible;

        for (DataPlot dp : parent.data)
        {
            data.add(new DataPlot(dp, zcc, aggreg_type));
        }
        
        
    }
    public DataPicturePane(String name, int data_width)
    {
        this(name, null, null, data_width);
    }
    public DataPicturePane(String name, PlotYAxisImage header, int data_width)
    {
        this(name, null, header, data_width);
    }

    public DataPicturePane(String name, Object o, PlotYAxisImage header, int data_width)
    {
        super(name);
        if(null==(this.header=header))
        {
            this.header=new PlotYAxisImage();
        }
        this.data_width=data_width;
        userObject=o;
    }

    /** constructor to initialize from serialized object */
    public DataPicturePane(Element e)
    {
        super(XMLUtils.getAttrib(e, "name", null, true));
        data_width=XMLUtils.getIntAttrib(e, "width", null);

        this.header = new PlotYAxisImage();

        for (Element dpe : XMLUtils.getChildren(e, DataPlot.ELEM_NAME))
        {
            DataPlot dp = new DataPlot(dpe);
            data.add(dp);
            data_visible.add(true);
        }
        update();
    }

    public Element getSerializedXML()
    {
        Element root = new Element(ELEM_NAME);
        root.setAttribute("width", ""+data_width);
        root.setAttribute("name", ""+getName());

        for (int i=0; i<data.size(); i++)
        {
            if (!data_visible.get(i))
                continue;
            
            DataPlot dp = data.get(i);
            root.addContent(dp.getSerializedXML());
        }

        return root;
        
    }
    public int getDataWidth()
    {
        return data_width;
    }
    public PlotYAxisImage getHeader()
    {
        return header;
    }
    
    
    public void setObject(Object o)
    {
        userObject=o;
    }

    java.awt.Graphics2D data_graphics = null;


    public Pair<Double,Double> getDataRange()
    {
        Double minv=null;
        Double maxv=null;
        for (int i=0; i<data.size(); i++)
        {
            Pair<Double, Double> p = data.get(i).getDataRange();
            if (p==null)
            {
                continue;
            }
            if (minv == null || minv > p.getFirst())
            {
                minv = p.getFirst();
            }
            if (maxv == null || maxv < p.getSecond())
            {
                maxv = p.getSecond();
            }
        }
        return new Pair<Double,Double>(minv,maxv);
    }

        
    
    static AwtGraphics awt_helper = new AwtGraphics(null);

    public int getHeight()
    {
        return (header==null)?0:header.getHeight();
    }
    
    public void paintSlice(java.awt.Graphics g, int x1, int y1, int x2, int y2, java.awt.image.ImageObserver obs)
    {
        awt_helper.g2 = (Graphics2D)g;
        paintSlice(awt_helper, x1,y1, x2, y2);
    }
    public void paintSlice(DGraphics g2, int x1, int y1, int x2, int y2)
    {
        int text_height=g2.getFontHeight();
        int data_y=text_height;

        for (int i=0; i<data.size(); i++)
        {
            
            if (!data_visible.get(i))
            {
                continue;
            }
            //System.out.println("will draw data "+i+" to "+g2);
            data.get(i).plot(header, g2, x1, x2);
            g2.setColor(data.get(i).color);

            g2.drawString(data.get(i).getName(), 0, data_y);
            data_y+=text_height;
        }


    }
    public void update()
    {
        //calculate the max/min value of the data
        
        //log.info("update");
        int dloc = getDividerLocation();
        
        //Pair<Double,Double> p = getDataRange();
        //header.setMaxValue(p.getSecond());
        //header.setMinValue(p.getFirst());
        BufferedImage himg = header.getImage(true);
        /*BufferedImage dataimg = ImageUtils.getWhiteImage(data_width, himg.getHeight());
        Graphics2D g2 = dataimg.createGraphics();
        
        
        int text_height=ImageUtils.getDrawnTextDimension(g2, "a").getSecond();
        int data_y=text_height;

        for (int i=0; i<data.size(); i++)
        {
            
            if (!data_visible.get(i))
            {
                continue;
            }
            //System.out.println("will draw data "+i+" to "+g2);
            data.get(i).plot(header, g2);
            g2.setColor(data.get(i).color);

            g2.drawString(data.get(i).getName(), 0, data_y);
            data_y+=text_height;
        }

        g2.dispose();
        */
        
        setSlicers(ImageScrollPane.getSlicer(himg),this);
        data_pane.getPanel().addMouseListener(this);
        data_pane.getPanel().addMouseMotionListener(this);
        updateMenu();
        setDividerLocation(dloc);
    }
    public void clearData()
    {
        data_graphics=null;
    }

    public DataPlot addData(String name, Color c)
    {
        return addData(name,c, null);
    }
    public DataPlot addData(String name, Object o)
    {
        return addData(name,cit.next(),o);
    }
    public DataPlot addData(String name)
    {
        return addData(name, cit.next(),null);
    }
    public DataPlot addData(String name, Color c, Object o)
    {
        DataPlot rv = new DataPlot(header, data_width);
        rv.setName(name);
        rv.setColor(c);
        rv.setObject(o);


        data.add(rv);
        data_visible.add(true);
        return rv;

    }
    
}


