package lmu.utils.plotting;


import lmu.utils.*;
import java.beans.*;
import lmu.utils.ImageUtils.ImagePanel;
import java.awt.image.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;


public class HeaderedPicturePane extends JSplitPane implements javax.swing.event.ChangeListener
{
    //protected BufferedImage header_img;
    //protected BufferedImage data_img;

    Object userObject=null;
    String name;
    public ImageScrollPane header_pane;
    protected ImageScrollPane data_pane;

    Integer highlightX=null;

    public void drawHighLight(Integer x)
    {
        data_pane.getPanel().updateUI(); //.reloadPicture();

        
        if (null==(highlightX=x))
        {
            return;
        }
        Graphics2D g =(Graphics2D)data_pane.getPanel().getGraphics();
        g.setColor(Color.DARK_GRAY);

        g.drawLine(highlightX, 0,highlightX, data_pane.getSlicerHeight());

            
    }
    public interface ContentInfoListener
    {
        public void contentChanged(HeaderedPicturePane hpp);

        public void mouseClickedOnPane(HeaderedPicturePane hpp, java.awt.event.MouseEvent e);
    }

    Vector<ContentInfoListener> listeners = new Vector<ContentInfoListener>();

    public void addListener(ContentInfoListener ccl)
    {
        listeners.add(ccl);
    }

    public void removeListener(ContentInfoListener ccl)
    {
        listeners.remove(ccl);
    }

    public void notifyListeners(java.awt.event.MouseEvent e)
    {
        for (ContentInfoListener ccl: listeners)
        {
            ccl.mouseClickedOnPane(this, e);
        }
    }

    public void notifyListeners()
    {
        for (ContentInfoListener ccl: listeners)
        {
            ccl.contentChanged(this);
        }
    }
    public String toString()
    {
        return "hpp: "+name+" ::"+super.toString();
    }
    public void setObject(Object o)
    {
        userObject=o;
    }
    
    public Object getUserObject()
    {
        return userObject;
    }
    public String getName()
    {
        return name;
    }

    public void setMenuBar(JMenuBar jb)
    {

    }

    
    public void setSlicers(SliceImageDrawer sid1,  SliceImageDrawer sid2)
    {
        header_pane.setSlicer(sid1);
        data_pane.setSlicer(sid2);
        setDividerLocation(header_pane.getSlicerWidth());
    }
    public void setImages(BufferedImage h, BufferedImage data)
    {
        header_pane.setImage(h);
        data_pane.setImage(data);
        //header_pane.setPreferredSize(new Dimension(h.getWidth(), h.getHeight()));
        setDividerLocation(header_pane.getSlicerWidth());
        
        
        
        //setMaximumSize(new Dimension(200, 20));
        /*System.out.println("\n\nset images to "+getName());
        System.out.println("header pane max dim : "+header_pane.getMaximumSize());
        System.out.println("data pane max dim : "+data_pane.getMaximumSize());
        */
       
        //data_pane.setPreferredSize(new Dimension(data.getWidth(), data.getHeight()));
        
       
        
        //setMaximumSize(new Dimension(data.getHeight(), h.getHeight()+data.getHeight()));
        //setPreferredSize(new Dimension(data.getHeight(), h.getHeight()+data.getHeight()));
    }

    public java.awt.Dimension getPictureDimension()
    {
        return new java.awt.Dimension(getDataWidth(), getPictureHeight());
    }
    public int getHeaderWidth()
    {
        return header_pane.getSlicerWidth();
    }
    public int getDataWidth()
    {
        return (data_pane==null)?0:data_pane.getSlicerWidth();
    }

    public int getImageWidth()
    {
        return getDataWidth();
    }

    public int getImageHeight()
    {
        return getPictureHeight();
    }
    public int getPictureWidth()
    {
        return 40+getHeaderWidth()+getDataWidth();
    }
    public int getPictureHeight()
    {
        return (int)header_pane.getMaximumSize().getHeight();
    }
    
    public BufferedImage getDataImage()
    {
        getPictureHeight();
        getHeaderWidth();
        getDataWidth();
        return data_pane.getFullImage();
    }
    public BufferedImage getHeaderImage()
    {
        getPictureHeight();
        //getHeaderWidth();
        getDataWidth();
        //header_pane.getSlicerHeight();
        return header_pane.getFullImage();
    }
    public BufferedImage getConcatImage(int header_width)
    {
        BufferedImage bim = ImageUtils.getInsetImage(header_width, header_pane.getSlicerHeight(), header_pane.getFullImage());
        return ImageUtils.concat(bim, data_pane.getFullImage());
    }

    

    public HeaderedPicturePane(String name)
    {
        this(name, null);
    }
    public HeaderedPicturePane(String name, Object o)
    {
        super(JSplitPane.HORIZONTAL_SPLIT);
        
        setObject(o);
        this.name=name;
        /*header = getImage(200, 500, Color.LIGHT_GRAY);
        data = getImage(12000, 500, Color.RED);
         
        header.createGraphics().drawString(name, 100, 200);
        */

        header_pane = new ImageScrollPane();

        
        header_pane.getViewport().addChangeListener(this);

        
        data_pane = new ImageScrollPane();

        
        data_pane.getViewport().addChangeListener(this);

        //setDividerLocation(200);
        //setPreferredSize(new java.awt.Dimension(2200, 200))_plot.setVisible(true);;

        setLeftComponent(header_pane);
        setRightComponent(data_pane);
        
    }

    public Dimension getMaxFrameDimension()
    {
        Dimension d1 = header_pane.getMaximumSize();
        Dimension d2 = data_pane.getMaximumSize();
        return new Dimension((int)(d1.getWidth()+d2.getWidth()), -10+(int)d1.getHeight());
    }
    public void stateChanged(ChangeEvent e)
    {
        
        JViewport vp = (JViewport)e.getSource();
        
        JViewport target = (header_pane.getViewport()==vp)?data_pane.getViewport():header_pane.getViewport();

        
        double y = vp.getViewPosition().getY();
        double x = target.getViewPosition().getX();

        target.setViewPosition(new java.awt.Point((int)x,(int)y));
        
        //System.out.println("got: state changed in "+e.getSource()+" "+vp.getViewPosition());
    }

    /*public int getWidth()
    {
        int w =  header_pane.getSlicerWidth() + data_pane.getSlicerWidth();
        System.out.println("HPP "+getName()+" WIDTH: "+w+" header: "+header_pane.getSlicerWidth() + " data: "+ data_pane.getSlicerWidth());

        return w;
    }
    */

    public Integer getDataX(JViewport jv)
    {
        if (jv!=data_pane.getViewport())
            return null;
        
        return (int)data_pane.getViewport().getViewPosition().getX();
    }

    public void scrollDataToX(int x)
    {
        data_pane.getViewport().setViewPosition(new java.awt.Point(x, (int)data_pane.getViewport().getViewPosition().getY()));
    }


}



