package lmu.utils.plotting;

import lmu.utils.*;

import java.beans.*;
import lmu.utils.ImageUtils.ImagePanel;
import java.awt.image.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.geom.*;

public class ImageScrollPane extends JScrollPane
{
    
    RedrawPanel testp = null;

    AffineTransform transform = null; //new AffineTransform();

			
    MouseEvent cloneEvent(MouseEvent me)
    {

        if (transform==null)
        {
            return me;
        }
        Point2D.Double p = new Point2D.Double(me.getX(), me.getY());

        Point2D real=null;
        try
        {
            real = transform.inverseTransform(p,null);
        }
        catch(NoninvertibleTransformException ne)        
        {
                throw new RuntimeException("error at drawing...:"+ne.getMessage(), ne);
        }
        
        /*public MouseEvent(Component source, int id, long when, int modifiers,
                      int x, int y, int xAbs, int yAbs,
                      int clickCount, boolean popupTrigger, int button) 
         */
        return new MouseEvent((Component)me.getSource(), me.getID(), me.getWhen(), me.getModifiers(),
                       (int)real.getX(), (int)real.getY(), me.getXOnScreen(), me.getYOnScreen(),
                       me.getClickCount(), me.isPopupTrigger(), me.getButton());
    }

    Vector<MouseListener> listeners = new Vector<MouseListener>();

    public void addListener(MouseListener ml)
    {
        listeners.add(ml);
        
    }

    public void removeListener(MouseListener ml)
    {
        listeners.remove(ml);
    }
    
    private class ScaleHandler implements MouseWheelListener , KeyListener, java.awt.event.MouseListener
    {
            public void mouseClicked(MouseEvent e)
            {
                
                for (MouseListener ml : listeners)
                {
                    ml.mouseClicked(cloneEvent(e));
                }
                
            }


            public void mousePressed(MouseEvent e)
            {
                for (MouseListener ml : listeners)
                {
                    ml.mousePressed(cloneEvent(e));
                }
                
            }

            public void mouseReleased(MouseEvent e)
            {
                for (MouseListener ml : listeners)
                {
                    ml.mouseReleased(cloneEvent(e));
                }
                
                
            }

            public void mouseEntered(MouseEvent e)
            {
                for (MouseListener ml : listeners)
                {
                    ml.mouseEntered(cloneEvent(e));
                }
                
            }


            public void mouseExited(MouseEvent e)
            {
                for (MouseListener ml : listeners)
                {
                    ml.mouseExited(cloneEvent(e));
                }
                
            }

        public void keyTyped(KeyEvent e)
        {
            //System.out.println("key typed: "+e);
            if (!e.isControlDown())
                return;
            
            if(e.getKeyChar()=='+')
            {
                zoomIn();
                return;
            }

            if(e.getKeyChar()=='-')
            {
                zoomOut();
                return;
            }
        }

         public void keyPressed(KeyEvent e)
        {
            //System.out.println("key pressed: "+e);
        }
        /**
         * Invoked when a key has been released.
         * See the class description for {@link KeyEvent} for a definition of
         * a key released event.
         */
        public void keyReleased(KeyEvent e)
        {
        }
        double unit=1.0;

        int width=0;
        int height=0;

        public void zoom(double amount)
        {
            if (transform==null)
            {
                return;
            }
            //System.out.println("will zoom : "+amount);

            double scalex = 1+(0.1*amount);
            double scaley = 1+(0.1*amount);
            
            //System.out.printf("new scale: %2.3f %2.3f\n", scalex, scaley);
            transform.scale(scalex, scaley);
            
            testp.updateUI();
            Point2D old = new Point2D.Double(testp.slicer.getImageWidth(), testp.slicer.getImageHeight());
            Point2D np = transform.transform(old, null);

            
            width=(int)np.getX();
            height=(int)np.getY();
            Dimension panel_d = new Dimension(width+30, height+50);

            //System.out.printf("current size: %d x %d against: %d x %d\n", width, height, testp.slicer.getWidth(), testp.slicer.getHeight());
            testp.setPreferredSize(panel_d);
            //canvas.scale += (.1 * amount);
            // don't cross negative threshold.
            // also, setting scale to 0 has bad effects
            //canvas.scale = Math.max(0.00001, canvas.scale); 
            //canvas.repaint();

        }
        public void zoomIn()
        {
            //System.out.println("zoomIn invoked!");
            zoom(unit);
        }

        public void zoomOut()
        {
            //System.out.println("zoomOut invoked!");
            zoom(-unit);
        }

        public void mouseWheelMoved(MouseWheelEvent e) 
        {
                    
            if(e.getScrollType() == MouseWheelEvent.WHEEL_UNIT_SCROLL) 
            {
                zoom(e.getWheelRotation());

            }
        }
    }
    
    

    public void supportScaling(boolean b)
    {
        if (!b)
        {
            transform=null;
        }
        else
        {
            transform =new AffineTransform();
        }
    }
    public ImageScrollPane()
    {

    }

    //ImagePanel ip=null;

    public JPanel getPanel()
    {
        return testp;
    }
    int height_offset=20;
    int width_offset=200;
    

    public int getSlicerWidth()
    {
        return testp.slicer.getImageWidth();
    }

    public int getSlicerHeight()
    {
        return testp.slicer.getImageHeight();
    }
    public void setSlicer(SliceImageDrawer sid)
    {
        testp = new RedrawPanel(sid);
        
        testp.setFocusable(true);
        
        Dimension panel_d = new Dimension(sid.getImageWidth()+30, sid.getImageHeight()+30);

        Dimension orig_d = new Dimension((int)panel_d.getWidth(), 30+(int)panel_d.getHeight());
        setViewportView(testp);
        testp.setPreferredSize(panel_d);
        testp.setSize(panel_d);

        scalehandler.width=sid.getImageWidth();
        scalehandler.height=sid.getImageHeight();

        testp.addKeyListener(scalehandler);
        testp.addMouseWheelListener(scalehandler);
        
        testp.addMouseListener(scalehandler);
        //testp.ad
        //testp.addM

        Dimension d = new Dimension((int)panel_d.getWidth(),  (int)panel_d.getHeight());
        getViewport().setPreferredSize(panel_d);
        //Dimension md = new Dimension((int)panel_d.getWidth(),  (int)ip.getPreferredSize().getHeight());
        setMaximumSize(orig_d);
        setPreferredSize(orig_d);
        setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);


    }

    public BufferedImage getFullImage()
    {
        /*System.out.printf("will save image oriinal: %d x %d scaler: %d x %d\n",
                          testp.slicer.getImageWidth(), testp.slicer.getImageHeight(),
                          scalehandler.width, scalehandler.height
                          );
        */
        BufferedImage bim = ImageUtils.getWhiteImage(scalehandler.width, scalehandler.height);
        Graphics2D g2 = bim.createGraphics();

         g2.setColor(Color.WHITE);
         
         if (transform!=null)
         {
             g2.setTransform(transform);
         }
        
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                       RenderingHints.VALUE_ANTIALIAS_ON);
         g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
                       RenderingHints.VALUE_TEXT_ANTIALIAS_ON);			


        testp.slicer.paintSlice(g2,0,0, testp.slicer.getImageWidth(), testp.slicer.getImageHeight(), null);
        g2.dispose();
        return bim;

    }
    public void setImage(BufferedImage bim)
    {
        //ip = new ImagePanel(bim);
        
        setSlicer(new RedrawImage(bim));
        
        
    }
    
    public class RedrawPanel extends JPanel
    {
        SliceImageDrawer slicer = null;

        RedrawPanel(SliceImageDrawer sid)
        {
            slicer=sid;
        }

        public void paint(Graphics g)
        {
            

            JViewport jvp = ImageScrollPane.this.getViewport();
            Rectangle r = jvp.getViewRect();
            //System.out.println("will redraw: "+r);

            Point2D.Double in_start = new Point2D.Double(r.getX(), r.getY());
            Point2D.Double in_end = new Point2D.Double(r.getMaxX(), r.getMaxY());


            //System.out.println("current transform: "+transform);
            Point2D out_start=in_start;
            Point2D out_end=in_end;
            if (transform!=null)
            {
                
                try
                {
                    out_start = transform.inverseTransform(in_start, null);
                    out_end = transform.inverseTransform(in_end, null);
                }
                catch(NoninvertibleTransformException ne)
                {
                    throw new RuntimeException("error at drawing...:"+ne.getMessage(), ne);
                }
            }

            
            //System.out.println("in original space: "+out_start+","+out_end);
            out_start=in_start;
            out_end=in_end;

            
            //System.out.println("in original space: "+out_start+","+out_end);
            
            
            Graphics2D g2 = (Graphics2D) g;
            g2.setColor(Color.WHITE);
            
            g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                            RenderingHints.VALUE_ANTIALIAS_ON);
            g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
                            RenderingHints.VALUE_TEXT_ANTIALIAS_ON);			

            

            int width=(int)(out_end.getX()-out_start.getX());
            int height=(int)(out_end.getY()-out_start.getY());
            
            g2.setColor(Color.WHITE);
            g2.fillRect((int)in_start.getX(), (int)in_start.getY(), (int)(in_end.getX()-in_start.getX()), (int)(in_end.getY()-in_start.getY()));
            
            /*AffineTransform old = g2.getTransform();
            if (transform!=null)
            {
                g2.setTransform(transform);
            }
            */
            
            g2.setColor(Color.WHITE);

            

            g2.fillRect((int)out_start.getX(), (int)out_start.getY(), width+10, height+10);
            slicer.paintSlice(g2, (int)out_start.getX(), (int)out_start.getY(), (int)out_end.getX(), (int)out_end.getY(), this);

            //g2.setTransform(old);
            
            
       }

    }

    public static SliceImageDrawer getSlicer(BufferedImage bim)
    {
        return new RedrawImage(bim);
    }
    public static class RedrawImage implements SliceImageDrawer
    {
        BufferedImage bim=null;
        int w=0;
        int h=0;

        public int getImageHeight()
        {
            return h;
        }
        public int getImageWidth()
        {
            return w;
        }
        public RedrawImage(BufferedImage bim)
        {
            this.bim=bim;
            w=bim.getWidth();
            h=bim.getHeight();
        }
        public void paintSlice(Graphics g, int x1, int y1, int x2, int y2, ImageObserver obs)
        {
            int maxx=(int)Math.min(w,x2);
            int maxy=(int)Math.min(h,y2);
            
            if (maxx-x1<=0 || maxy-y1<=0)
            {
                return;
            }
            
            
            g.drawImage(bim.getSubimage(x1,y1,maxx-x1, maxy-y1),
                        x1, y1, maxx-x1, maxy-y1, obs);
        }
        
    }
    public void paintComponent(Graphics g)
    {
        JViewport jvp = getViewport();
        
        
        Rectangle r = jvp.getVisibleRect();//jvp.getViewRect();
        /*Graphics2D g2=(Graphics2D)testp.getGraphics();
        g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION,RenderingHints.VALUE_INTERPOLATION_BILINEAR);
        
        g2.drawImage(save, (int)r.getX(), (int)r.getY(), (int)r.getWidth(), (int)r.getHeight(), this);
        g2.dispose();
        */

        //System.out.println("image scrollpane will paint ocmponent visible part: "+jvp.getViewRect());
        super.paintComponent(g);
    }
    public void paint(Graphics2D g)
    {
        JViewport jvp = getViewport();
        
        //System.out.println("scrollpane will paint visible part: "+jvp.getViewRect());
        
             
        
        super.paint(g);
    }
    
    ScaleHandler scalehandler = new ScaleHandler();

    public ImageScrollPane(ImagePanel ip)
    {
        super(ip, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
        setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);

        


            
        
    }
    
    public ImageScrollPane(int x, int y, Color c)
    {
        this(new ImagePanel(ImageUtils.getImage(x,y,c)));
        
    }
}



