package lmu.utils.plotting;

import javax.swing.JFrame;
import java.awt.image.BufferedImage;
import org.jdom.*;

public class ZoomedMultiPicPlaneFrame extends JFrame implements ZoomedMultiPicPlane
{
    
    AbstractZoomedMultiPicPlane zpp = null;
    public ZoomedMultiPicPlaneFrame(int width)
    {
        super();
        zpp = new AbstractZoomedMultiPicPlane(null, this, width);
        

    }
    public ZoomedMultiPicPlaneFrame(AbstractZoomedMultiPicPlane ampp)
    {
        super();
        zpp = ampp;
        zpp._frame = this;
    }

    public ZoomedCoordinateConverter getZoomedConverter()
    {
        return zpp.getZoomedConverter();
    }

    public void reset(int nlength)
    {
        zpp.reset(nlength);

    }
    public void addInfo(HeaderedPicturePane hpp)
    {
        zpp.addInfo(hpp);
    }

    public void update(boolean force)
    {
        zpp.update(force);
    }

    public void update()
    {
        zpp.update();
    }
    public BufferedImage getCombinedImage()
    {
        return zpp.getCombinedImage();
    }

    public void setZoomedConverter(ZoomedCoordinateConverter zoom_converter)
    {
        zpp.setZoomedConverter(zoom_converter);
    }
    public RegionPicturePane createRegionPane(String name)
    {
        return zpp.createRegionPane(name);
    }
   
    public RegionPicturePane createRegionPane(String name, Object userObject)
    {
        return zpp.createRegionPane(name,userObject);
    }
    public DataPicturePane createDataPane(String name)
    {
        return zpp.createDataPane(name);
    }
    public DataPicturePane createDataPane(String name, Object userObject)
    {
        return zpp.createDataPane(name,userObject);
    }

    public RegionPicturePane addRegionPane(RegionPicturePane rpp)
    {
        return zpp.addRegionPane(rpp);
    }
    public DataPicturePane addDataPane(DataPicturePane dpp)
    {
        return zpp.addDataPane(dpp);
    }
       
    public void setPreferredSize(java.awt.Dimension prefSize)
    {
        super.setPreferredSize(prefSize);

        System.out.println("\n\n\nset pref size to : "+prefSize+"\n\n");
        zpp.setPreferredSize(prefSize);
    
    }

    public Element getSerializedXML()
    {
        return zpp.getSerializedXML();
    }
    public void init(Element e)
    {
        zpp.init(e);
    }   

    public void setAutoSize()
    {

        java.awt.Dimension screend = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setAutoSize((int)screend.getWidth()-50, (int)screend.getHeight()-50);
    }
    

    public void setAutoSize(int maxx, int maxy)
    {
        
        java.awt.Dimension maxsize = getMaximumSize();
        int prefmax_x=(int)maxsize.getWidth()+30;
        int prefmax_y=(int)maxsize.getHeight()+50;
        setSize(Math.min(prefmax_x,maxx), Math.min(prefmax_y, maxy));
        //ImageUtils.showImage("combined", _plot.getCombinedImage());
        //zpp.setMaximumSize(Math.min((int)maxsize.getWidth()+20, maxx), Math.min((int)maxsize.getHeight()+20, maxy));

    }
    public void setHidden(HeaderedPicturePane pane, boolean b)
    {
        zpp.setHidden(pane,b);
    }

    public void removePane(String name)
    {
        //not yet implemented
    }

}
