package lmu.utils.swing;


import lmu.utils.*;
import java.beans.*;
import lmu.utils.ImageUtils.ImagePanel;
import java.awt.image.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


/** component which handles multiple internal frames
 * having all the same width, but resizible/hiddenable
 * on the y axis
 */
public class MultiFrameWindow extends JFrame implements 
                        java.awt.event.ActionListener
                        

{
    
    Logger log = LogConfig.getLogger();

    class IFChangeListener implements ComponentListener
    {
        public void componentResized(ComponentEvent e)
        {
            Component c = (Component)e.getSource();
            
            if (c==MultiFrameWindow.this)
            {
                //System.out.println("got multipic plane resize from : "+c+ " new size: "+c.getSize()+" max height: "+maxheight);
                int nh = c.getHeight();
                if (maxheight>0)
                {
                    nh = Math.min(nh, (int)getSize().getHeight());
                }
                Dimension nd = new Dimension(c.getWidth(), nh);
                //c.setSize();
                setIFSizes();
                /*MultiPicPlane.this.setPreferredSize(nd);
                MultiPicPlane.this.setSize(nd);
                MultiPicPlane.this.setMaximumSize(new Dimension(1500, maxheight));
                */
                return;
            }
            
            int fi=-1;
            if (0>(fi = frames.indexOf(c)))
                return;
            
            
            int w = MultiFrameWindow.this.getWidth();
            //int nheight = Math.min((int)c.getSize().getHeight(), (int)c.getPreferredSize().getHeight());
            int nheight=(int)c.getSize().getHeight();
            c.setPreferredSize(new Dimension(w,nheight));
            
        }
    
        /**
         * Invoked when the component's position changes.
         */    
        public void componentMoved(ComponentEvent e)
        {
            Component c = (Component)e.getSource();
            //System.out.println("got moved from : "+c+ " new size: "+c.getSize());

        }
    
        /**
         * Invoked when the component has been made visible.
         */
        public void componentShown(ComponentEvent e)

        {
            Component c = (Component)e.getSource();
            //System.out.println("got shown from : "+c+ " new size: "+c.getSize());
        }
    
        /**
         * Invoked when the component has been made invisible.
         */
        public void componentHidden(ComponentEvent e)
        {
            Component c = (Component)e.getSource();
            //System.out.println("got hidden from : "+c+ " new size: "+c.getSize());
        }
    }
    static class IFListener implements InternalFrameListener
    {
        MultiFrameWindow parent;

        IFListener(MultiFrameWindow parent)
        {
            this.parent=parent;
        }
        public void internalFrameActivated(InternalFrameEvent e)
        {
        }
        public void internalFrameOpened(InternalFrameEvent e)
        {
        }
        public void internalFrameClosing(InternalFrameEvent e)
        {
            parent.frameClosed(e.getInternalFrame());
        }
        public void internalFrameDeactivated(InternalFrameEvent e)
        {
        }
        public void internalFrameClosed(InternalFrameEvent e)
        {
        }
        public void internalFrameIconified(InternalFrameEvent e)
        {
        }
        public void internalFrameDeiconified(InternalFrameEvent e)
        {
        }
    }


    boolean is_setup=false;
    IFListener iflistener = new IFListener(this);
    IFChangeListener ifchange_listener = new IFChangeListener();

    public void setVisible(boolean a)
    {
        if (a)
        {
            is_setup=true;
        }
        super.setVisible(a);
    }
    

    public void actionPerformed(java.awt.event.ActionEvent e)
    {
        //System.out.println("got event: "+e.getActionCommand());
        int toshow=-1;
        for(int i=0; i<visible_items.size(); i++)
        {
            if(e.getSource()!=visible_items.get(i))
                continue;
            toshow=i;
        }
        if (toshow<0)
            return;
        
        
        hidden.set(toshow,false);
        update();
            
    }
        
        /**
         * Invoked when an internal frame is in the process of being closed.
         * The close operation can be overridden at this point.
         * @see javax.swing.JInternalFrame#setDefaultCloseOperation
         */
        public void frameClosed(JInternalFrame frame)
        {
            setHidden(frame, true);
            update();
            
            
        }
                    
        int maxheight=-1;
        public void update()
        {
            panel=new JPanel();
            
            
            maxheight=0;


            int divloc=0;
            panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
            for (int i=0; i<frames.size(); i++)
            {
                
                JInternalFrame jif = frames.get(i);
                //jif.setPreferredSize(new Dimension(hp.getPreferredSize()));
                if (hidden.get(i))
                {
                    visible_items.get(i).setVisible(true);
                    continue;
                }
                jif.setVisible(true);
                //panel.add(new JScrollPane(jif));
                log.debug("frmae: "+jif.getTitle()+" pref size: "+jif.getPreferredSize());
                panel.add(jif);
                
                visible_items.get(i).setVisible(false);
            }
            setContentPane(new JScrollPane(panel));
            log.debug("panel pref size: "+panel.getPreferredSize());
            pack();
            setPreferredSize(panel.getPreferredSize());

            

        }
                    
        JPanel panel = new JPanel();
        Vector<JInternalFrame> frames = new Vector<JInternalFrame>();
        Vector<Boolean> hidden = new Vector<Boolean>();
        Vector<JMenuItem> visible_items = new Vector<JMenuItem>();


        public void setHidden(JInternalFrame ji, boolean b)
        {
            for (int i=0; i<frames.size(); i++)
            {
                if (ji!=frames.get(i))
                {
                    continue;
                }
                hidden.set(i,b);
                visible_items.get(i).setVisible(true);

                return;
            }
        }

        JMenuBar jmb = new JMenuBar();
        JMenu jm = new JMenu("set visible");

        public MultiFrameWindow()
        {
            super();
            
            
            setJMenuBar(jmb);

            jmb.add(jm);

            addComponentListener(ifchange_listener);
            
        }


        /** removes all panes */
        public void clear()
        {
            panel = new JPanel();
            jm.removeAll();
            frames.clear();
            visible_items.clear();
            hidden.clear();
        }
        
        public void addFrameComponent(Container c, String name)
        {
            JInternalFrame jif = new JInternalFrame();
            jif.setClosable(true);
            
            jif.setContentPane(new JScrollPane(c));
            jif.setPreferredSize(c.getPreferredSize());
            Dimension d = c.getPreferredSize();
            jif.setPreferredSize(new Dimension((int)(d.getWidth()-20.0), (int)d.getHeight()));
            jif.pack();
            jif.setAutoscrolls(true);
            log.debug("add componenet: "+name+" pref size: "+c.getPreferredSize());
            addFrame(jif, name);
        }
        public void removeFrame(JInternalFrame jif)
        {
            int idx=-1;
            for (int i=0; i<frames.size(); i++)
            {
                if (frames.get(i)!=jif)
                    continue;
                
                idx=i;
                break;
            }
            if (idx<0)
            {
                return;
            }

            frames.removeElementAt(idx);
            hidden.removeElementAt(idx);
            jm.remove(visible_items.get(idx));
            visible_items.removeElementAt(idx);
            panel.remove(jif);
            update();
        }
        public void addFrame(JInternalFrame jif, String name)
        {
            log.debug("MFW add internal frame: "+name);
            jif.setTitle(name);
            jif.setAutoscrolls(true);
            //jif.setMinimumSize(new Dimension(30,20));
            jif.setResizable(true);
            JMenuItem ji = new JMenuItem("show "+name);
            jm.add(ji);
            ji.setVisible(false);
            visible_items.add(ji);

            ji.addActionListener(this);
            frames.add(jif);
            hidden.add(false);
            jif.setClosable(true);
            jif.setDefaultCloseOperation(jif.HIDE_ON_CLOSE);
            jif.setVisible(true);
            
            //jif.setClosable(true);
            jif.addInternalFrameListener(iflistener);
            jif.addComponentListener(ifchange_listener);
            jif.pack();
            
            panel.add(jif);

            log.debug("MFW add frame: "+name+" pref size: "+jif.getPreferredSize());

            //setPreferredSize(panel.getPreferredSize());
            
            //pack();
        }
        void setIFSizes()
        {
            if(true)return;
            Dimension d = getSize();
            for (JInternalFrame jif : frames)
            {
                double h = jif.getPreferredSize().getHeight();
                jif.setPreferredSize(new Dimension((int)d.getWidth(), (int)h));
            }
        }
        /*public void setPreferredSize(Dimension d)
        {
            int nh = (int)d.getHeight();
            if (maxheight>0)
            {
                
                nh = Math.min(maxheight, nh);
                d = new Dimension((int)d.getWidth(), nh);
            }
            

            System.out.println("mPP set preferred size: "+d+"  maxheight:"+maxheight);
            super.setPreferredSize(d);
            
            //resize all internal frames
            setIFSizes();
        }
        */
}
