package lmu.utils.swing;

import lmu.utils.*;
import java.util.*;
import javax.swing.*;

public class PagedDataTableModel extends PagingModel implements DataTable.DataFilterListener
{

    Vector<Boolean> directions =new Vector<Boolean>();
    
    public boolean toggleSortOrder(int column) 
    {
        boolean norder=false;
        directions.set(column, norder=!directions.get(column));
        ReflectedObject ro = dt.header.getHeader(column).getRefObj();
        System.out.println("sort by : column:"+column+" "+ro);
        ObjectGetter.sortBy(dt.getFilteredData(),ro, norder);
        return norder;
        
    }

    
    DataTable dt;

    public void filterChanged(DataTable.FilterSet new_filter, int new_size)
    {
        
        
        data_size = dt.getFilteredSize();
        System.out.printf("filter changed new size: %d data size: %s\n", new_size, data_size);
        fireTableDataChanged();

    }

    public PagedDataTableModel(DataTable dt)
    {
        super(50,dt.getSize());
        this.dt=dt;
        for (int i=0; i<dt.getNumHeaders(); i++)
        {
            directions.add(false);
        }
        
        dt.addDataFilterListener(this);
    }

    public Object getRowObject(int row)
    {
        return getValueAt(row,0);
    }
    /**
     * Returns the number of columns in the model. A
     * <code>JTable</code> uses this method to determine how many columns it
     * should create and display by default.
     *
     * @return the number of columns in the model
     * @see #getRowCount
     */
    public int getColumnCount()
    {
        return dt.header.getVisibleHeaderSize();
    }
    /**
     * Returns the value for the cell at <code>columnIndex</code> and
     * <code>rowIndex</code>.
     *
     * @param	rowIndex	the row whose value is to be queried
     * @param	columnIndex 	the column whose value is to be queried
     * @return	the value Object at the specified cell
     */
    public Object getValueAt(int rowIndex, int columnIndex)
    {
        //return dt.data.get(rowIndex).get(columnIndex);
        
        return dt.getDataAt(getPageOffset()*getRowCount() + rowIndex);//.get(columnIndex);
    }



    
    
}
