package lmu.utils.swing;

import lmu.utils.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;


public class PagingHeader  extends JPanel implements TableModelListener
{
    JPanel panel = new JPanel();
    JButton prev = new JButton("<");
    JButton tostart = new JButton("<<");

    JTextField pagenumber = new JTextField("0");
    JLabel totalpages = new JLabel("/0");

    JLabel regioninfo = new JLabel("");
    JButton next = new JButton(">");
    JButton toend = new JButton(">>");
    PagingModel model;

    public PagingHeader(PagingModel model)
    {
        super();
        JPanel panel=this;
        this.model=model;
        panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));

        pagenumber.setColumns(5);
        
        //prev.setActionCommand("ok");                                                                
        tostart.addActionListener(new ReflectedObjectListener(new ReflectedObject("toStart()"), this));
        prev.addActionListener(new ReflectedObjectListener(new ReflectedObject("prevPage()"), model));
        next.addActionListener(new ReflectedObjectListener(new ReflectedObject("nextPage()"), model));
        toend.addActionListener(new ReflectedObjectListener(new ReflectedObject("toEnd()"), this));
        pagenumber.addActionListener(new ReflectedObjectListener(new ReflectedObject("toPage()"), this));
        update();
        panel.add(tostart);
        panel.add(prev);
        panel.add(pagenumber);
        panel.add(totalpages);
        panel.add(regioninfo);
        panel.add(next);
        
        panel.add(toend);

        //add(panel);
        


        
        model.addTableModelListener(this);


        update();

        panel.setMaximumSize(panel.getPreferredSize());
        panel.setAutoscrolls(true);
        //setViewportView(panel);
        
    }

    public void toPage()
    {
        try
        {
            model.toPage(Integer.parseInt(pagenumber.getText()));
        }
        catch(Exception e)
        {
        }
        
    }
    public void toStart()
    {
        model.toPage(0);
    }
    public void toEnd()
    {
        model.toPage(model.getPageCount()-1);
    }
    public void tableChanged(TableModelEvent e)
    {
        System.out.println("got event: "+e);
        update();
    }
    
    public void update()
    {
        
        pagenumber.setText(""+model.getPageOffset());
        pagenumber.setColumns(5);
        totalpages.setText("/"+model.getPageCount()+" ");

        regioninfo.setText(String.format("(%d-%d total: %d)", (model.getPageOffset())*model.getPageSize(), 
                                         Math.min((model.getPageOffset()+1)*model.getPageSize(), model.getRealRowCount()),
                                         model.getRealRowCount()));

        //updateUI();
        //panel.setMaximumSize(panel.getPreferredSize());
        //panel.setMinimumSize(panel.getPreferredSize());

        //setMaximumSize(panel.getPreferredSize());

    }
}
