package lmu.utils.tuple;

import java.util.*;
import lmu.utils.*;

public class Tuple4<A,B,C,D> extends Tuple3<A,B,C>
{
    public Tuple4()
    {
        super();
    }
    public Tuple4(A a, B b, C c, D d)
    {
        super(a,b,c,d);
    }

    public static<A,B,C,D> Tuple4<A,B,C,D> create(A a, B b ,C c, D d)
    {
        return new Tuple4<A,B,C,D>(a,b,c,d);
    }
    
    public D getFourth()
    {
        return (D) get(3);
    }


    public D get3()
    {
        return (D) get(3);
    }


    public void set3(D d)
    {
        set(3, d);
    }

    static class Tuple4Getter<A,B,C,D> implements Iterator<Tuple4<A,B,C,D>>
    {
        DataTable.TupleGetter tg;
        int row_idx = 0;
        int num_rows =0;

        Tuple4Getter(DataTable dt, String header1, String header2, String header3, String header4)
        {
            
            num_rows = dt.getSize();
            tg = dt.getTupleGetter(header1, header2, header3, header4);
        }

        public boolean hasNext()
        {
            return row_idx < num_rows;
        }

        public Tuple4<A,B,C,D> next()
        {
            Tuple t = tg.get(row_idx++);
            return new Tuple4<A,B,C,D>((A)t.get(0), (B)t.get(1), (C)t.get(2), (D)t.get(3));
        }
    }


    public static<A,B,C,D> Iterator<Tuple4<A,B,C,D>> getIterator(DataTable dt, String header1, String header2, String header3, String header4)
    {
        return new Tuple4Getter<A,B,C,D>(dt, header1, header2, header3, header4);
    }
}
