package fasta;

import java.util.regex.*;

public class RegexGroupParser implements HeaderParser<String[]>
{

    Pattern pat = null;

    public RegexGroupParser(String regexp)
    {
        this(Pattern.compile(regexp));
    }
    public RegexGroupParser(Pattern p)
    {
        pat = p;
    }


    public String[] parse(String fasta_header)
    {
        Matcher m= pat.matcher(fasta_header);
        if (!m.matches())
        {
            throw new RuntimeException("error, fasta header :>"+fasta_header+"< does not match to configured pattern: "+pat.pattern()+" search:?"+m.find());
        }
        String rv[]=new String[m.groupCount()];

        for (int i=0; i<m.groupCount(); i++)
        {
            rv[i]=m.group(i+1);
        }
        return rv;
    }
    
}
