package protein.algo.external;

import java.io.*;

import java.util.*;

import lmu.utils.RegionVector;

public 	abstract class MultipleAlignmentAlgo{
	public static class ExternalException extends Exception{
		public ExternalException(String message){
			super(message);
		}
		public ExternalException(String message,Exception e){
			super(message,e);
		}
	}
	
	public abstract StringBuffer[] align(File intput,List<String> ids) throws ExternalException;
	
	public abstract boolean isoformStructureSupport();
	
	public static void printInfos(PrintWriter pw,RegionVector exons){
		pw.write(";C join(");
		for(int i = 0 ; i< exons.size();i++ ){
			pw.print(exons.get(i).getX1() + ".." + (exons.get(i).getX2()-1));
			if ( i< exons.size()-1) pw.print(", ");
		}
		pw.write(")");
		pw.write("\n");
		pw.flush();
	}
}
